<?php
/**
 * config.php
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package config
 * @author Stephan Raabe
 */

/*
------------------------------------------------------------------------
URL SETTINGS
------------------------------------------------------------------------
*/

/**
 * openEngine website url
 * Url to website.php
 * @var string
 */
$oe_site_url = "http://127.0.0.1/openengine/cms";

/**
 * openEngine website url with account data
 * Url to website.php
 * @var string
 */
// $oe_site_url_https = "https://username:password@127.0.0.1/cms";

/*
------------------------------------------------------------------------
DATABASE SETTINGS
------------------------------------------------------------------------
*/

/**
 * MySQL Server
 * @var string
 */
$db_server = "localhost";

/**
 * MySQL Username
 * @var string
 */
$db_user = "root";

/**
 * MySQL Password
 * @var string
 */
$db_password = "";

/**
 * MySQL Database for openEngine
 * @var string
 */
$db_name = "openengine";

/**
 * Table Praefix
 * (for more than one openEngine installation in a single database)
 * @var string
 */
$db_praefix	= "oe_";

/*
------------------------------------------------------------------------
SYSTEM SETTINGS
------------------------------------------------------------------------
*/

/**
 * System character encoding
 * @var string
 */
$site_encoding = "utf-8";

/**
 * Extranet flag
 * true = enable extranet functions
 * false = disable extranet functions
 * @var bool
 */
$oe_system_extranet = false;

/**
 * Prototype Library flag
 * true = writes the prototype/script.acul.us javascript to the html body
 * false = if you have already included the prototype/script.acul.us javascript in the html head section, set the variable to false
 * @var bool
 */
$oe_system_prototype = true;

/**
 * Definition of session timeout in seconds
 * @var int
 */
$oe_session_timeout = 3600;

/**
 * Definition of page block that will be used in sitestructure dialog
 * @var bool
 */
$oe_structure_block = "page_headline";

/*
------------------------------------------------------------------------
SECURITY SETTINGS
------------------------------------------------------------------------
*/

/**
 * HTTPS support
 * true = HTTPS support is enabled for the openEngine backend
 * false = HTTPS support is disabled
 * @var bool
 */
$oe_https = false;

/**
 * Password repeat
 * true = authors have to change their password, when administrator defines a new password
 * false = authors don't have to change their password
 * @var bool
 */
$oe_security_repeatauthorpassword = true;

/**
 * number of possible invalid password inputs during login
 * after that, the account is locked
 * @var int
 */
// $oe_security_passwordlockrepeat = 3;

/**
 * Account locktime in minutes after password lock
 * @var int
 */
// $oe_security_passwordlocktime = 20;

/**
 * New password time in minutes
 * After that time, the author have to define a new password
 * @var int
 */
// $oe_security_passwordchangetime = 129600;

/**
 * HTML whitelist
 * in that page blocks html tags are allowed to save in the database
 * @var string
 */
$oe_html_whitelist = "export_content,page_teaser,page_text1,page_text2,page_text3,page_text4,page_text5,page_text6,stage_input,nl_html,re_name,re_value,str_value,template_source,template_backup1,template_backup2,template_backup3,page_xmlcontent,page_xmlrhc,replace_content";

/**
 * Cookie is only readable by server scripts
 * Note: Only available at PHP 5.2+
 * @var bool
 */
$oe_cookie_httponly = false;

/**
 * Enables the CSRF Check
 * @var bool
 */
$oe_csrf = true;

/**
 * Allows to change order for neighbour sites next to the permission point
 * @var bool
 */
$oe_neighbour_order = true;

/*
------------------------------------------------------------------------
DIRECTORY SETTINGS
------------------------------------------------------------------------
*/

/**
 * openEngine template path
 * Relative path to template directory
 * @var string
 */
$oe_template_path = "templates";

/**
 * openEngine pool path
 * Relative path to filepool directory
 * @var string
 */
$oe_pool_path = "../root/img/pool";

/**
 * openEngine cache path
 * Relative path to cache directory
 * @var string
 */
$oe_cache_path = "../root/img/cache";

/**
 * openEngine module path
 * Relative path to module directory
 * @var string
 */
$oe_log_path = "";

/**
 * Path to 404 Page, releative to website.php
 * @var string
 */
$oe_error_page = "../root/404.php";

/**
 * openEngine system lock path
 * Relative path to the system lock page
 * @var string
 */
$oe_systemlock_path = "../root/systemlock.php";

/**
 * openEngine class path
 * Server path to openEngine classes directory
 * @var string
 */
// $oe_classpath = "";

/**
 * openEngine system path
 * Server path to openEngine system directory
 * @var string
 */
// $oe_systempath = "";
?>