<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Action
{
	/**
	* Klasse mit Datenbankmethoden
	*
	* @var Database
	*/	
	private $db;

	/**
	* Tabellen Pr�fix f�r Datenbank-Zugriffe
	*
	* @var string
	*/	
	private $prefix;

	/**
	* Klasse mit Seitenmethoden
	*
	* @var Page
	*/	
	private $page;

	/**
	* Klasse mit Benutzermethoden
	*
	* @var User
	*/	
	private $user;

	/**
	* Klasse mit Dialogmethoden
	*
	* @var Dialog
	*/	
	private $dialog;

	/**
	* Klasse mit Systemeinstellungen
	*
	* @var Settings
	*/	
	private $set;

	/**
	* Klasse mit Filtermethoden
	*
	* @var Filter
	*/	
	private $filter;
	
	/**
	* Klasse mit Sessionmethoden
	*
	* @var Session
	*/	
	private $session;
	
	/**
	* Klasse mit Sessionmethoden
	*
	* @var Extranet
	*/	
	private $extranet;
		
	/**
	* Klasse mit FilePool Methoden
	*
	* @var FilePool
	*/	
	private $filepool;
	
	/**
	* Klasse mit Strcuture Methoden
	*
	* @var FilePool
	*/	
	private $structure;	

	/**
	* Klasse mit AJAX Methoden
	*
	* @var Ajax
	*/	
	private $ajax;
	
	/**
	* Klasse mit Export Methoden
	*
	* @var Ajax
	*/	
	private $export;
	
	/**
	* Konstruktor
	*/	
	public function Action()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_dialog,$oe_set,$oe_session,$oe_extranet,$oe_filepool,$oe_ajax,$oe_sitestructure,$oe_export;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->dialog = $oe_dialog;
		$this->set = $oe_set;
		$this->session = $oe_session;
		$this->extranet = $oe_extranet;
		$this->filepool = $oe_filepool;
		$this->ajax = $oe_ajax;
		$this->structure = $oe_sitestructure;
		$this->export = $oe_export;
	}
	
	/**
	* Verarbeitung der Dialogeingaben
	*/	
	public function adminAction()
	{
		global $page;
		if ($this->user->isAdmin())
		{
			if (isset($_POST["action"]))
			{
				$oe_log = new Log();
				$oe_log->writeLog($_SESSION["account_email"],$_POST["action"],$page["page_path"],$this->set->getLogPath());
				$oe_changedate = new Changedate();
				$oe_changedate->init();
				if ($this->set->checkCSRF())
				{
					SecureSession::verify($_POST["account_randomkey"]);
				}
				switch ($_POST["action"]) 
				{
					case "filepool_init":
						$this->sendBackend($this->filepool,"init",array(),0);
					break;

					case "filepool_loadTree":
						$this->sendBackend($this->filepool,"loadTree",array(),0);
					break;
					
					case "filepool_loadPath":
						$this->sendBackend($this->filepool,"loadPath",array(),0);
					break;
					
					case "filepool_newFolder":
						$this->sendBackend($this->filepool,"newFolder",array(),0,"account_filepoolfolder");
					break;
							
					case "filepool_renameFolder":
						$this->sendBackend($this->filepool,"renameFolder",array(),0,"account_filepoolfolder");
					break;
					
					case "filepool_checkDeleteFolder":
						$this->sendBackend($this->filepool,"checkDeleteFolder",array(),0);
					break;
					
					case "filepool_deleteFolder":
						$this->sendBackend($this->filepool,"deleteFolder",array(),0,"account_filepoolfolder");
					break;
			
					case "filepool_subFolders":
						$this->sendBackend($this->filepool,"subFolders",array(),0);
					break;
			
					case "filepool_cutFolder":
						$this->sendBackend($this->filepool,"cutFolder",array(),0,"account_filepoolfolder");
					break;
					
					case "filepool_getFiles":
						$this->sendBackend($this->filepool,"getFiles",array(),0);
					break;
			
					case "filepool_getpermission":
						$this->sendBackend($this->filepool,"getPermission",array(),2);
					break;
			
					case "filepool_getforpermission":
						$this->sendBackend($this->filepool,"getForPermission",array(),2);
					break;
			
					case "filepool_savepermission":
						$this->sendBackend($this->filepool,"savePermission",array(),2);
					break;
			
					case "filepool_saveforpermission":
						$this->sendBackend($this->filepool,"saveForPermission",array(),2);
					break;
							
					case "filepool_refreshFile":
						$this->sendBackend($this->filepool,"refreshFile",array(),2);
					break;
			
					case "filepool_refreshFileFolder":
						$this->sendBackend($this->filepool,"refreshFolder",array(),2);
					break;
					
					case "filepool_getFileInfo":
						$this->sendBackend($this->filepool,"getFileinfo",array(),0,"account_filepool");
					break;
					
					case "filepool_saveFileInfo":
						$this->sendBackend($this->filepool,"saveFileInfo",array(),0,"account_filepool");
					break;		
			
					case "filepool_cutFile":
						$this->sendBackend($this->filepool,"cutFile",array("key","folder"),0,"account_filepool");
					break;	
					
					case "filepool_deleteFile":
						$this->sendBackend($this->filepool,"deleteFile",array("key"),0,"account_deletefile");
					break;
			
					case "filepool_deleteCache":
						$this->sendBackend($this->filepool,"deleteCache",array(),2);
					break;
			
					case "filepool_deleteFolderCache":
						$this->sendBackend($this->filepool,"deleteFolderCache",array(),2);
					break;
					
					case "filepool_checkDeleteFile":
						$this->sendBackend($this->filepool,"checkDeleteFile",array("key"),0);
					break;
	
					case "filepool_createThumbnails":
						$this->sendBackend($this->filepool,"createThumbnails",array("key"),0);
					break;					
	
					case "filepool_deleteThumbnails":
						$this->sendBackend($this->filepool,"deleteThumbnails",array("key"),0);
					break;
										
					case "filepool_createFolderThumbnails":
						$this->sendBackend($this->filepool,"createFolderThumbnails",array("folder_key"),0);
					break;
	
					case "filepool_getThumbnailList":
						$this->sendBackend($this->filepool,"getThumbnailList",array(),0);					
					break;
					
					case "filepool_getListView":
						$this->sendBackend($this->filepool,"getListView",array(),0);					
					break;
					
					case "menu_saveMenu":
						$this->sendBackend($this->ajax,"saveMenu",array(),0);					
					break;
		
					case "menu_appearMenu":
						$this->sendBackend($this->ajax,"appearMenu",array(),0);					
					break;
					
					case "page_checkpagepath":
						$this->sendBackend($this->ajax,"checkPagePath",array(),0);					
					break;
		
					case "page_checkuserpassword":
						$this->sendBackend($this->ajax,"checkPassword",array(),0);					
					break;
								
					case "settings":
						$this->sendBackend($this->dialog,"updateSettings",array("page_key","site_name","site_admin","lang_default","account_register","site_staging","button_style","template_location","upload_chmod","default_type","debugging","export_stepsize","edit_scroll","page_permissions","menu_mode","system_theme","company_logo","export_mode","page_meta1","page_meta2","page_meta3","page_meta4","page_meta5","page_meta6","page_meta7","page_meta8","page_meta9","page_meta10","site_meta1","site_meta2","site_meta3","site_meta4","filepool_mode","password_length","password_complexity","site_help"),2);					
					break;

					case "updatecss": 
						$this->sendBackend($this->dialog,"updateCss",array("page_key","site_css"),2);					
					break;
					
					case "properties":
						$this->sendBackend($this->dialog,"updateProperties",array("page_key","page_path","page_extern","page_headline","page_title","page_keywords","page_description","page_template","page_att1","page_att2","page_navigation","page_include","page_hide","page_meta1","page_meta2","page_meta3","page_meta4","page_meta5","page_meta6","page_meta7","page_meta8","page_meta9","page_meta10","page_tags","page_date"),1);					
					break;			
					
					case "authorization": 
						$this->sendBackend($this->dialog,"updateAuthorization",array("page_key","page_status","status_subpages","page_redirect"),1);					
					break;
					
					case "addpage": 
						$this->sendBackend($this->dialog,"addPage",array("page_key","page_pathnew","page_headline","page_title","page_keywords","page_description","page_template","page_att1","page_att2","page_navigation"),1);					
					break;
					
					case "user": 
						$this->sendBackend($this->dialog,"updateUser",array("account_key","account_password","account_firstname","account_lastname","account_editor","account_emailold","account_group","account_password_old"),0);					
					break;
					
					case "message": 
						$this->sendBackend($this->dialog,"sendMessage",array("msg_receiver","msg_subject","msg_message","msg_from"),0);					
					break;
					
					case "addaccount":
						$this->sendBackend($this->dialog,"addAccount",array("page_key","account_email","account_password","account_firstname","account_lastname","account_telefon","account_company","account_group","account_lock"),2);					
					break;
					
					case "editaccount": 
						$this->sendBackend($this->dialog,"updateAccount",array("page_key","account_key","account_email","account_password","account_firstname","account_lastname","account_telefon","account_company","account_homepage","account_group","account_lock","account_info","account_lang","account_editor","account_access","account_delpage","account_exportpage","account_profile","account_uploadfile","account_deletefile","account_filepool","account_releasepage","account_importfile","account_orderpage","account_treelink","account_thumbnail","account_lock_old"),2);					
					break;
					
					case "deletepage": 
						if (($this->user->pagePermission($_POST["page_key"])) && ($_SESSION["account_delpage"] == 1))
						{
							if (($_SESSION["account_group"] == 2) && (isset($_POST["direct_delete"])))
							{
								$_POST["delete_full"] = 1;
							}
							$this->sendBackend($this->dialog,"deletePage",array("page_key"),1);											
						}
					break;
					
					case "edittemplate": 
							$this->sendBackend($this->dialog,"updateTemplate",array("page_key","template_key","template_name","template_description","template_select","template_hide","template_short","template_lockexport","template_include","template_permission"),2);
					break;
					
					case "release": 
						if (($this->user->pagePermission($_POST["page_key"])) && ($_SESSION["account_releasepage"] == 1))
						{ 
							$this->sendBackend($this->dialog,"releasePage",array("page_key","block","okexport"),1);
						}
					break;
					
					case "updateremark": 
						$this->sendBackend($this->dialog,"remarkPage",array("page_key","page_remark"),1);
					break;
					
					case "updatetemplatesource": 
						$this->sendBackend($this->dialog,"templateSource",array("page_key","template_name","template_source"),2);
					break;
					
					case "savebackup": 
						$this->sendBackend($this->dialog,"saveSource",array("template_name","template_source","template_version"),2);
					break;
					
					case "loadbackup": 
						$this->sendBackend($this->dialog,"loadSource",array("template_name","template_version"),2);
					break;
					
					case "edittext": 
						$this->sendBackend($this->dialog,"editText",array(),1);
					break;

					case "edithtml":
						if (isset($_POST["encode"]))
						{
							$_POST["page_input"] = htmlspecialchars($_POST["page_input"]);
						}
						$this->sendBackend($this->dialog,"editText",array(),1);
					break;
										
					case "editphp":
						$this->sendBackend($this->dialog,"updateText",array("page_key","page_edit","page_input"),2);
					break;
					
					case "editdate":
						$this->sendBackend($this->dialog,"editDate",array(),1);
					break;	
					
					case "newdata": 
						$this->sendBackend($this->dialog,"addPage",array("page_key","page_pathnew","page_headline","page_headline","page_keywords","page_description","page_template","page_att1","page_att2","page_headline"),1);
					break;
					
					case "navigation": 
						$this->sendBackend($this->dialog,"updateNavigation",array("page_key","keys"),1);
					break;
					
					case "grouporder": 
						$this->sendBackend($this->dialog,"updateGroupOrder",array("page_key","keys"),2);
					break;
					
					case "delstatistic": 
						$this->sendBackend($this->dialog,"delStatistic",array(),2);
					break;
					
					case "addTableItem": 
						$this->sendBackend($this->dialog,"addTableItem",array(),2);
					break;
					
					case "delTableItem": 
						$this->sendBackend($this->dialog,"delTableItem",array(),2);
					break;
					
					case "editTableItem": 
						$this->sendBackend($this->dialog,"editTableItem",array(),2);
					break;
					
					case "upload": 
						$this->sendBackend($this->dialog,"updateText",array("page_key","field","page_upFile"),1);
					break;
					
					// Structure
					case "structure_loadTree":
						$this->sendBackend($this->structure,"loadTree",array(),0);
					break;
									
					case "structure_subFolders":
						$this->sendBackend($this->structure,"subFolders",array(),0);
					break;
					
					case "structure_forceexport":
						$this->sendBackend($this->structure,"forceExport",array(),0);
					break;
			
					case "structure_restorepage":
						$this->sendBackend($this->structure,"restorePage",array(),0);
					break;
							
					case "structure_releasecontent":
						$this->sendBackend($this->structure,"releaseContent",array(),0);
					break;
	
					case "structure_getPage":
						$this->sendBackend($this->structure,"getPage",array(),0);
					break;
			
					case "structure_getPath":
						$this->sendBackend($this->structure,"getPath",array(),0);
					break;
			
					case "structure_cutFolder":
						$this->sendBackend($this->structure,"cutFolder",array(),0);
					break;
					
					case "structure_copyFolder":
						$this->sendBackend($this->structure,"copyFolder",array(),0);
					break;
			
					case "structure_copystartsite":
						$this->sendBackend($this->structure,"copyStartsite",array(),0);
					break;
							
					case "structure_deletepagecache":
						$this->sendBackend($this->structure,"deletePagecache",array(),0);
					break;
			
					case "structure_deletetrash":
						$this->sendBackend($this->structure,"deleteTrash",array(),0);
					break;
							
					case "structure_getstartsite":
						$this->sendBackend($this->structure,"getStartsite",array(),0);
					break;
			
					case "structure_gethtmlexport":
						$this->sendBackend($this->structure,"getHtmlExport",array(),0);
					break;
					
					case "structure_getrss":
						$this->sendBackend($this->structure,"getRSS",array(),0);
					break;
	
					case "structure_saverss":
						$this->sendBackend($this->structure,"saveRSS",array(),0);
					break;
					
					case "structure_editstartsite":
						$this->sendBackend($this->structure,"editStartsite",array(),0);
					break;
					
					case "structure_newstartsite":
						$this->sendBackend($this->structure,"newStartsite",array(),0);
					break;
					
					case "structure_getpermission":
						$this->sendBackend($this->structure,"getPermission",array(),0);
					break;		
					
					case "structure_deletepage":
						$this->sendBackend($this->structure,"deletePage",array(),0);
					break;
				
					case "structure_getforpermission":
						$this->sendBackend($this->structure,"getForPermission",array(),0);
					break;	
			
					case "structure_gettreelink":
						$this->sendBackend($this->structure,"getTreelinks",array(),0);
					break;	
			
					case "structure_gettreecontent":
						$this->sendBackend($this->structure,"getTreecontent",array(),0);
					break;
					
					case "structure_checktreelink":
						$this->sendBackend($this->structure,"checkTreelinks",array(),0);
					break;
					
					case "structure_savetreelink":
						$this->sendBackend($this->structure,"saveTreelink",array(),0);
					break;
					
					case "structure_savepermission":
						$this->sendBackend($this->structure,"savePermission",array(),0);
					break;
			
					case "structure_saveforpermission":
						$this->sendBackend($this->structure,"saveForPermission",array(),0);
					break;
			
					case "structure_searchpage":
						$this->sendBackend($this->structure,"searchPage",array(),0);
					break;

					case "export_checkExport":
						$this->sendBackend($this->export,"checkExport",array(),0);
					break;
	
					case "export_getExportFiles":
						$this->sendBackend($this->export,"getExportFiles",array(),0);
					break;
							
					case "export_startExport":
						$this->sendBackend($this->export,"startExport",array(),0);
					break;
					
					case "export_updateDate":
						$this->sendBackend($this->export,"updateDate",array(),0);
					break;
					
					case "export_cleanup":
						$this->sendBackend($this->export,"cleanup",array(),0);
					break;					
				}
			}
		}		
	}

	/**
	* Verarbeitung der Logineingaben
	*/	
	public function pageAction()
	{
		global $admin_lang,$page;
		if (isset($_POST["action"]))
		{
			switch ($_POST["action"])
		    {
				case "loginInt":
					if (!$this->user->login($_POST["account_email"],$_POST["account_password"]))
					{
						$admin_lang["profile"][1] = $admin_lang["profile"][2];
					}
				break;

				case "loginExtranet":
					$this->extranet->login($_POST["account_email"],$_POST["account_password"]);
				break;

				case "logoutExtranet":
					$this->extranet->logout();
				break;

				case "passwordInt":
					$this->user->password($_POST["account_password"],$_POST["account_password_new"]);
				break;
				
				case "logoutInt": 
					$this->user->logout($this->set->getSiteUrl());
				break;
			}
		}		
	}
	
	/**
	 * Anbindung Backend 
	 */
	private function sendBackend($instance,$function,$vars,$perm,$auth = "")
	{
		$varoutArr = array();
		$eval = false;
		foreach ($vars as $value)
		{
			array_push($varoutArr,$_POST[$value]);
		}
		if ($this->user->isAdministrator())
		{
			$eval = true;
		}
		else
		{
			if ($_SESSION["account_group"] == 3)
			{
				switch ($perm)
				{
					case 0:
						$eval = true;
					break;
					
					case 1:
						if ($this->user->pagePermission($_POST["page_key"]))
						{
							if ($auth != "")
							{
								if ($_SESSION[$auth] == 1)
								{
									$eval = true;	
								}
							}
							else
							{
								$eval = true;	
							}
						}
					break;
					
					case 2:
						if ($this->user->isAdministrator())
						{
							$eval = true;
						}
					break;
				}				
			}
		}
		if ($eval)
		{
			call_user_func_array(array($instance,$function),$varoutArr);
		}
	}
}
?>