<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Changedate
{
	private $db;
	private $prefix;
	private $set;
	private $page;
	
	/**
	 * Konstruktor
	 *
	 * @return Changedate
	 */
	public function Changedate()
	{
		global $oe_db,$db_praefix,$oe_set,$oe_page;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->set = $oe_set;
	}
	
	/**
	 * Initialisiert die Aktualisierung des Datums.
	 *
	 */
	public function init()
	{
		if (($_POST["action"] == "properties") ||
			($_POST["action"] == "copypage") ||
			($_POST["action"] == "cutpage") ||
			($_POST["action"] == "deletepage") ||
			($_POST["action"] == "release") ||
			($_POST["action"] == "edittext") ||
			($_POST["action"] == "navigation") ||
			($_POST["action"] == "authorization") ||
			($_POST["action"] == "settings") ||
			($_POST["action"] == "upload"))
		{
			$pageArr = $this->page->getPageKey($_POST["page_key"]);
			$page_status = $pageArr["page_status"];
			$this->updateChanger($_POST["page_key"]);
			if (($page_status == 0) || ($_POST["action"] == "authorization"))
			{
				if (($this->set->getSiteStaging() != 1) || ($_POST["action"] != "edittext"))
				{
					$this->update($_POST["page_key"]);
				}
			}
		}
	}
	
	/**
	 * Aktualisiert das Seitendatum
	 *
	 * @param int $page_key ID der Seite
	 * @param bool $onlycurrent 	false: Aktuelle Seite und alle Unterseiten werden gendert.
	 * 								true: Nur die aktuelle Seite wird gendert.
	 */
	public function update($page_key,$onlycurrent = false)
	{
		$page_exportdate = date("Y-m-d H:i:s");
		if ($onlycurrent)
		{
			$param = array("page_exportdate" => $page_exportdate,"page_key" => $page_key);
			$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_key = :page_key";
			$this->db->update($query,$param);
		}
		else 
		{
			$oe_helper = new Helper();
			if ((isset($_POST["action"])) && ($_POST["action"] == "settings"))
			{
				if ($_POST["site_name"] != $_POST["site_name_old"])
				{
					$param = array("page_exportdate" => $page_exportdate);
					$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate";
					$this->db->update($query,$param);
				}
			}
			else 
			{
				if ($oe_helper->getDepth($page_key) <= 2)
				{
					$param = array("page_exportdate" => $page_exportdate);
					$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate";
					$this->db->update($query,$param);
				}
				else
				{
					$pageKey = $this->page->getPageKey($page_key);

					$param = array("page_exportdate" => $page_exportdate,"page_parent" => $pageKey["page_parent"],"page_key" => $pageKey["page_parent"]);
					$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_parent = :page_parent";
					$this->db->update($query,$param);

					$param = array("page_exportdate" => $page_exportdate,"page_parent" => $pageKey["page_parent"],"page_key" => $pageKey["page_parent"]);
					$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_parent = :page_key";
					$this->db->update($query,$param);

					$param = array("page_exportdate" => $page_exportdate,"page_parent" => $pageKey["page_parent"],"page_key" => $pageKey["page_parent"]);
					$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_key = :page_key";
					$this->db->update($query,$param);
					
					$this->updateRec($page_exportdate,$pageKey["page_key"]);
					$param = array("page_exportdate" => $page_exportdate);
					$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_forceexport = 1";
					$this->db->update($query,$param);
					$query = "SELECT page_key FROM ".$this->prefix."rss WHERE rss_export = 1";
					foreach ($this->db->select($query) as $row)
					{
						$param = array("page_key" => $row["page_key"]);
						$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_key = :page_key";
						$this->db->update($query,$param);
					}
				}
			}
		}
	}
	
	/**
	 * Aktualisiert das Exportdatum
	 *
	 * @param date $date nderungsdatum
	 * @param int $key ID der bergeordneten Seite
	 */
	public function updateRec($date,$key)
	{
		$param = array("page_parent" => $key);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent";
		foreach ($this->db->select($query,$param) as $row)
		{
			$param = array("page_exportdate" => $date,"page_key" => $row["page_key"]);
			$query = "UPDATE ".$this->prefix."page SET page_exportdate = :page_exportdate WHERE page_key = :page_key";
			$this->db->update($query,$param);
			$this->updateRec($date,$row["page_key"]);
		}
	}
	
	/**
	 * Aktualisiert den Autor
	 *
	 * @param int $page_key ID der Seite
	 */
	public function updateChanger($page_key)
	{
		$page_changer = $_SESSION["account_email"];
		$page_change = date("YmdHis");		
		$param = array("page_change" => $page_change,"page_changr" => $page_changer,"page_key" => $page_key);
		$query = "UPDATE ".$this->prefix."page SET page_change = :page_change, page_changer = :page_changr WHERE page_key = :page_key";
		$this->db->update($query,$param);
	}
}
?>