<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class DbTables
{
	var $tables;
	
	function DbTables()
	{
		$this->schema = array();
		
		$db_columns = array();
		array_push($db_columns,"account_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_email,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"account_password,varchar(255) default NULL,1");
		array_push($db_columns,"account_firstname,varchar(255) default NULL");
		array_push($db_columns,"account_lastname,varchar(255) NOT NULL default ''");
		array_push($db_columns,"account_telefon,varchar(255) default NULL");
		array_push($db_columns,"account_company,varchar(255) default NULL");
		array_push($db_columns,"account_homepage,varchar(255) NOT NULL default ''");
		array_push($db_columns,"account_group,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_access,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_info,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_nlsend,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_lang,varchar(10) NOT NULL default ''");
		array_push($db_columns,"account_lock,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_editor,varchar(255) NOT NULL default ''");
		array_push($db_columns,"account_menu,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_menux,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_menuy,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_random,varchar(255) NOT NULL default ''");
		array_push($db_columns,"account_releasepage,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_delpage,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_exportpage,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_profile,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_filepool,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_uploadfile,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_deletefile,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_filepoolfolder,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_importfile,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_orderpage,int(11) NOT NULL default '1'");
		array_push($db_columns,"account_treelink,int(11) NOT NULL default '1'");
		$this->tables["account,account_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"asset_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"asset_filename,varchar(255) NOT NULL default ''");
		array_push($db_columns,"asset_name,varchar(255) NOT NULL default ''");
		array_push($db_columns,"asset_keywords,text");
		array_push($db_columns,"folder_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"asset_alt,varchar(255) NOT NULL default ''");
		array_push($db_columns,"asset_params,varchar(255) NOT NULL default ''");
		array_push($db_columns,"asset_create,varchar(255) NOT NULL default ''");
		array_push($db_columns,"asset_creator,varchar(255) NOT NULL default ''");
		$this->tables["asset,asset_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"att_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"att_name,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"att_description,text");
		$this->tables["attribute,att_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"folder_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"folder_parent,int(11) NOT NULL default '0'");
		array_push($db_columns,"folder_name,varchar(255) NOT NULL default ''");
		$this->tables["filepool,folder_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"files_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"files_name,varchar(255) NOT NULL default ''");
		array_push($db_columns,"files_path,varchar(255) NOT NULL default ''");
		$this->tables["files,files_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"group_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"group_name,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"group_description,text");
		array_push($db_columns,"group_order,int(11) NOT NULL default '0'");
		$this->tables["group,group_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"lang_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"lang_short,varchar(255) NOT NULL default ''");
		array_push($db_columns,"lang_name,varchar(255) NOT NULL default ''");
		$this->tables["language,lang_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"nl_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"nl_subject,varchar(255) NOT NULL default ''");
		array_push($db_columns,"nl_sender,varchar(100) NOT NULL default ''");
		array_push($db_columns,"nl_date,varchar(50) NOT NULL default ''");
		array_push($db_columns,"nl_date_unformated,varchar(10) NOT NULL default ''");
		array_push($db_columns,"nl_test,varchar(100) NOT NULL default ''");
		array_push($db_columns,"nl_text,text");
		array_push($db_columns,"nl_html,text");
		array_push($db_columns,"nl_multi,int(11) NOT NULL default '0'");
		array_push($db_columns,"nl_target,varchar(250) NOT NULL default ''");
		array_push($db_columns,"nl_status,int(8) NOT NULL default '0'");
		$this->tables["newsletter,nl_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"page_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_parent,int(11) NOT NULL default '0',1");
		array_push($db_columns,"page_order,int(11) NOT NULL default '0',1");
		array_push($db_columns,"page_count,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_lang,varchar(20) NOT NULL default ''");
		array_push($db_columns,"page_date,varchar(20) NOT NULL default ''");
		array_push($db_columns,"page_date_unformated,varchar(10) NOT NULL default ''");
		array_push($db_columns,"page_status,int(11) NOT NULL default '0',1");
		array_push($db_columns,"page_access,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_path,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"page_extern,varchar(250) NOT NULL default ''");
		array_push($db_columns,"page_template,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_headline,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_title,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_navigation,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_keywords,text");
		array_push($db_columns,"page_description,text");
		array_push($db_columns,"page_teaser,text");
		array_push($db_columns,"page_text1,text");
		array_push($db_columns,"page_text2,text");
		array_push($db_columns,"page_text3,text");
		array_push($db_columns,"page_text4,text");
		array_push($db_columns,"page_text5,text");
		array_push($db_columns,"page_text6,text");
		array_push($db_columns,"page_file,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_file1,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_file2,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_file3,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_file4,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_file5,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_file6,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_att1,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_att2,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_start,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_hide,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_exportfolder,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_lockexport,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_remark,text");
		array_push($db_columns,"page_include,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_create,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_creator,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_change,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_changer,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_main,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_forceexport,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_userlock,int(11) NOT NULL default '0'");
		array_push($db_columns,"treelink_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_lang_alt,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta1,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta2,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta3,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta4,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_tags,text");
		array_push($db_columns,"page_exported,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_exportdate,datetime NOT NULL");
		array_push($db_columns,"page_exportmd5,varchar(255) NOT NULL default ''");
		$this->tables["page,page_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"re_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"re_name,varchar(255) NOT NULL default ''");
		array_push($db_columns,"re_value,varchar(255) NOT NULL default ''");
		$this->tables["replacing,re_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"settings_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"site_url,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_authurl,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_name,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_admin,varchar(255) NOT NULL default ''");
		array_push($db_columns,"system_directory,varchar(255) NOT NULL default ''");
		array_push($db_columns,"lang_default,varchar(255) NOT NULL default ''");
		array_push($db_columns,"lang_list,varchar(255) NOT NULL default ''");
		array_push($db_columns,"account_register,int(11) NOT NULL default '0'");
		array_push($db_columns,"site_staging,int(11) NOT NULL default '0'");
		array_push($db_columns,"site_css,text");
		array_push($db_columns,"site_help,varchar(255) NOT NULL default ''");
		array_push($db_columns,"menu_top,int(11) NOT NULL default '0'");
		array_push($db_columns,"nl_stepsize,int(11) NOT NULL default '50'");
		array_push($db_columns,"nl_timer,int(11) NOT NULL default '5'");
		array_push($db_columns,"nl_encoding,varchar(255) NOT NULL default ''");
		array_push($db_columns,"export_timer,int(11) NOT NULL default '5'");
		array_push($db_columns,"export_stepsize,int(11) NOT NULL default '50'");
		array_push($db_columns,"tree_static,int(11) NOT NULL default '0'");
		array_push($db_columns,"check_useragent,int(11) NOT NULL default '0'");
		array_push($db_columns,"log_path,varchar(255) NOT NULL default ''");
		array_push($db_columns,"button_style,text");
		array_push($db_columns,"template_location,int(11) NOT NULL default '0'");
		array_push($db_columns,"non_cookie,int(11) NOT NULL default '0'");
		array_push($db_columns,"direct_delete,int(11) NOT NULL default '1'");
		array_push($db_columns,"tree_currentlang,int(11) NOT NULL default '0'");
		array_push($db_columns,"upload_chmod,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_pool,varchar(255) NOT NULL default ''");
		array_push($db_columns,"template_path,varchar(255) NOT NULL default ''");
		array_push($db_columns,"default_type,varchar(255) NOT NULL default ''");
		array_push($db_columns,"debugging,int(11) NOT NULL default '0'");
		array_push($db_columns,"module_path,varchar(255) NOT NULL default ''");
		array_push($db_columns,"edit_scroll,int(11) NOT NULL default '0'");
		array_push($db_columns,"cache_path,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_permissions,int(11) NOT NULL default '0'");
		array_push($db_columns,"menu_mode,int(11) NOT NULL default '0'");
		array_push($db_columns,"system_theme,varchar(255) NOT NULL default 'grey'");
		array_push($db_columns,"company_logo,varchar(255) NOT NULL default ''");
		array_push($db_columns,"export_mode,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_meta1,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta2,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta3,varchar(255) NOT NULL default ''");
		array_push($db_columns,"page_meta4,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_meta1,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_meta2,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_meta3,varchar(255) NOT NULL default ''");
		array_push($db_columns,"site_meta4,varchar(255) NOT NULL default ''");
		array_push($db_columns,"filepool_mode,int(11) NOT NULL default '0'");
		array_push($db_columns,"field_list,varchar(255) NOT NULL default ''");
		$this->tables["settings,settings_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"perm_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"perm_type,int(11) NOT NULL default '0'");
		$this->tables["permission,perm_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"poolperm_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"folder_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"account_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"perm_type,int(11) NOT NULL default '0'");
		$this->tables["poolpermission,poolperm_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"stage_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"stage_edit,varchar(255) NOT NULL default ''");
		array_push($db_columns,"stage_input,text");
		$this->tables["stage,stage_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"str_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"str_name,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"str_select,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"str_value,text");
		$this->tables["stringpool,str_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"task_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"task_name,varchar(255) NOT NULL default ''");
		array_push($db_columns,"task_description,text");
		array_push($db_columns,"task_page,varchar(255) NOT NULL default ''");
		array_push($db_columns,"task_date,varchar(255) NOT NULL default ''");
		$this->tables["task,task_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"template_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"template_name,varchar(255) NOT NULL default '',1");
		array_push($db_columns,"template_description,text");
		array_push($db_columns,"template_select,varchar(255) NOT NULL default ''");
		array_push($db_columns,"template_hide,int(11) NOT NULL default '0'");
		array_push($db_columns,"template_short,varchar(255) NOT NULL default ''");
		array_push($db_columns,"template_lockexport,int(11) NOT NULL default '0'");
		array_push($db_columns,"template_source,text");
		array_push($db_columns,"template_backup1,text");
		array_push($db_columns,"template_backup2,text");
		array_push($db_columns,"template_backup3,text");
		array_push($db_columns,"template_include,int(11) NOT NULL default '0'");
		$this->tables["template,template_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"rss_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"page_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"rss_title,varchar(255) NOT NULL default ''");
		array_push($db_columns,"rss_description,text");
		array_push($db_columns,"rss_size,int(11) NOT NULL default '0'");
		array_push($db_columns,"rss_order,varchar(255) NOT NULL default ''");
		array_push($db_columns,"rss_export,int(11) NOT NULL default '0'");
		$this->tables["rss,rss_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"treelink_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"treelink_type,int(11) NOT NULL default '0'");
		$this->tables["treelink,treelink_key"] = $db_columns;
		
		$db_columns = array();
		array_push($db_columns,"meta_key,int(11) NOT NULL default '0'");
		array_push($db_columns,"meta_type,varchar(255) NOT NULL default ''");
		array_push($db_columns,"meta_description,varchar(255) NOT NULL default ''");
		array_push($db_columns,"meta_value,varchar(255) NOT NULL default ''");
		$this->tables["meta,meta_key"] = $db_columns;		
	}
}
?>