<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class ItemEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $set;
	private $output;
	private $adminLang;
	public $block;
	public $tooltip;
	public $pagekey;
	public $maxsize;
	public $returncontent;
	public $mode;
	public $width;
	public $style;
	public $textstyle;
	public $buttonstyle;
		
	public function ItemEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang,$oe_set;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->set = $oe_set;
		$this->block = "page_headline";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->maxsize = 0;
		$this->returncontent = true;
		$this->adminLang = $admin_lang;
		$this->mode = "popup";
		$this->width = "100%";	
		$this->style = "";
		$this->textstyle = "";
	}
	
	public function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if (($this->mode == "inline") && ($this->returncontent))
			{
				if ($this->set->getSiteStaging() == 0)
				{
					$input = $page[$this->block];
				}
				else
				{
					$input = $this->page->stagingOutput($this->block);
				}
				$input = trim($input);
				$release = 0;
				if ($this->set->getSiteStaging())
				{
					$release = 1;	
				}
				?><div id="oe_inline_buttons_<?php echo $this->block.$pageedit["page_key"]; ?>"><?php
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a id="oe_inline_releasebtn_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				else
				{
					?><a style="display:none;" id="oe_inline_releasebtn_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
				?><a href="Javascript:oe_showInlineItemEditor('<?php echo $this->block; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->width; ?>','<?php echo $_COOKIE["token"]; ?>','<?php echo $page["page_path"]; ?>',<?php echo $release; ?>,'<?php echo $this->style; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Inline-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_inline.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a></div>
<span id="oe_inline_text_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" style="<?php echo $this->textstyle; ?>"><?php echo $this->output->outputBlock($this->block,$pageedit["page_key"]); ?></span><?php				
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openItemeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>&amp;maxsize=<?php echo $this->maxsize; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Item-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a><?php
				if ($this->returncontent) 
				{ 
					echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
				}
			}			
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
	}
}

class TextEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	private $adminLang;
	private $set;
	public $block;
	public $tooltip;
	public $pagekey;
	public $returncontent;
	public $mode;
	public $type;
	public $width;
	public $height; 
	public $buttons;
	public $buttonstyle;
	
	function TextEditor()
	{
		global $oe_db,$oe_set,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->set = $oe_set;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->returncontent = true;
		$this->adminLang = $admin_lang;
		$this->mode = "popup";
		$this->width = "100%";
		$this->height = "150px";
		$this->buttons = "";
		$this->type = "";
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if (($this->mode == "inline") && ($this->returncontent))
			{
				if ($this->set->getSiteStaging() == 0)
				{
					$input = $page[$this->block];
				}
				else
				{
					$input = $this->page->stagingOutput($this->block);
				}
				$edit_lang = "en";
				if ($_SESSION["account_lang"] == "de")
				{
					$edit_lang = "de";
				}
				$release = 0;
				if ($this->set->getSiteStaging())
				{
					$release = 1;	
				}
				?>
				<script type="text/javascript">
				var oe_poolpath = '<?php echo $page["page_path"]; ?>';
				var oe_siteurl = '<?php echo $this->set->getSiteUrl(); ?>';
				</script>
				<div id="oe_inline_buttons_<?php echo $this->block.$pageedit["page_key"]; ?>">
				<?php
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a id="oe_inline_releasebtn_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				else
				{
					?><a style="display:none;" id="oe_inline_releasebtn_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
				?><a href="Javascript:oe_showInlineEditor('<?php echo $this->block; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->width; ?>','<?php echo $this->height; ?>','<?php echo $edit_lang; ?>','<?php echo $this->buttons; ?>','<?php echo $_COOKIE["token"]; ?>','<?php echo $page["page_path"]; ?>',<?php echo $release; ?>,'<?php echo $this->type; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Inline-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_inline.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a>
				</div>
				<div id="oe_inline_text_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>">
				<?php echo $this->output->outputBlock($this->block,$pageedit["page_key"]); ?>
				</div>
				<?php
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openTexteditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>&amp;editortype=<?php echo $this->type; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'WYSIWYG-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a><?php
				if ($this->returncontent) 
				{ 
					echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
				}
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
	}
}

class SimpleTextEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	private $adminLang;
	private $set;
	public $block;
	public $tooltip;
	public $pagekey;
	public $returncontent;
	public $maxsize;
	public $mode;
	public $width;
	public $height;
	public $linebreaks;
	public $style;
	public $textstyle;
	public $buttonstyle;
	
	function SimpleTextEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang,$oe_set;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->set = $oe_set;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->returncontent = true;
		$this->maxsize = 0;
		$this->adminLang = $admin_lang;
		$this->mode = "popup";
		$this->width = "100%";
		$this->height = "150px";
		$this->linebreaks = false;
		$this->style = "";
		$this->textstyle = "";
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if (($this->mode == "inline") && ($this->returncontent))
			{
				if ($this->set->getSiteStaging() == 0)
				{
					$input = $page[$this->block];
				}
				else
				{
					$input = $this->page->stagingOutput($this->block);
				}
				$input = trim($input);
				$release = 0;
				if ($this->set->getSiteStaging())
				{
					$release = 1;	
				}
				$linebreaks = 0;
				if ($this->linebreaks)
				{
					$linebreaks = 1;
				}
?><div id="oe_inline_buttons_<?php echo $this->block.$pageedit["page_key"]; ?>"><?php
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a id="oe_inline_releasebtn_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				else
				{
					?><a style="display:none;" id="oe_inline_releasebtn_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
				?><a href="Javascript:oe_showInlineSimpleEditor('<?php echo $this->block; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->width; ?>','<?php echo $this->height; ?>','<?php echo $_COOKIE["token"]; ?>','<?php echo $page["page_path"]; ?>',<?php echo $release; ?>,'<?php echo $this->style; ?>',<?php echo $linebreaks; ?>);" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Inline-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_inline.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a></div>
<span id="oe_inline_text_<?php echo $this->block; ?><?php echo $pageedit["page_key"]; ?>" style="<?php echo $this->textstyle; ?>"><?php echo $this->output->outputBlock($this->block,$pageedit["page_key"]); ?></span><?php				
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openSimpleTexteditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>&amp;maxsize=<?php echo $this->maxsize; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'SimpleText-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a><?php
				if ($this->returncontent) 
				{ 
					echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
				}
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
	}
}

class HTMLEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	public $block;
	public $tooltip;
	public $pagekey;
	public $returncontent;
	public $maxsize;
	private $adminLang;
	public $lockauthor;
	public $buttonstyle;
	
	function HTMLEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->returncontent = true;
		$this->maxsize = 0;
		$this->adminLang = $admin_lang;
		$this->lockauthor = false;
		$this->htmlencode = false;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}
		$encode = "";
		if ($this->htmlencode)	
		{
			$encode = "&encode=1";
		}
		if ((isset($_SESSION["account_group"]) && (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && (!$this->lockauthor)))) && (!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openHTMLeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>&amp;maxsize=<?php echo $this->maxsize; ?><?php echo $encode; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'HTML/Text-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
	}
}

class PHPEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $block;
	var $tooltip;
	var $pagekey;
	var $returncontent;
	var $adminLang;
	
	function PHPEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->returncontent = true;
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		$pageedit = $page;
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if ($_SESSION["account_group"] == 2)
			{
				if($this->page->isStage($pageedit["page_key"],$this->block))
				{
					if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
					{
						?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
					}
				} 
				?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openPHPeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'PHP-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
			}
			if ($this->returncontent) 
			{ 
				if (isset($_GET["export"]))
				{
					echo "<?php ".$this->output->outputBlock($this->block,$pageedit["page_key"])."?>";
				}
				else 
				{
					eval($this->output->outputBlock($this->block,$pageedit["page_key"]));
				}
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				if (isset($_GET["export"]))
				{
					echo "<?php ".$this->output->outputBlock($this->block,$pageedit["page_key"])."?>";
				}
				else 
				{
					eval($this->output->outputBlock($this->block,$pageedit["page_key"]));
				}
			}
		}
	}
}

class ReleaseEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $block;
	var $tooltip;
	var $pagekey;
	var $adminLang;
	
	function ReleaseEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_headline";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
		}
	}
}

class DateEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $block;
	var $tooltip;
	var $pagekey;
	var $returncontent;
	var $deletedate;
	var $adminLang;
	
	function DateEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_dateunformated";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->returncontent = true;
		$this->deletedate = true;
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			if ($this->deletedate)
			{
				$delete = 1;
			}
			else
			{
				$delete = 0;
			}
			?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openDateeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>&delete=<?php echo $delete; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Date-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_date.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputBlock($this->block,$pageedit["page_key"]); 
			}
		}
	}
}

class DeleteEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	private $currentpage;
	public $tooltip;
	public $pagekey;
	public $redirect;
	
	function DeleteEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$page;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->currentpage = $page;
		$this->redirect = $this->currentpage["page_key"];
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_delpage"] == 1)))
			{
				?><a href="Javascript:openSmallDialog('<?php echo $pageedit["page_path"]; ?>','delete&amp;redirect=<?php echo $this->redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Delete-Editor');" onmouseout="return nd();"><img src='system/img/oes_pagedelete.png' alt='' border='0' class='oe_editbutton'/></a><?php
			}
		}
	}
}

class NewPageEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	public $tooltip;
	public $pagekey;
	public $setpath;
	public $template;
	public $icon;
	public $values;
	private $values_key;
		
	public function NewPageEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$oe_classpath;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->setpath = true;
		$this->template = "default";
		$this->icon = "system/img/oes_addpage.png";

		$digit = 0;
		$output = "";
		for ($i = 1; $i <= 8; $i++) 
		{
  			do 
  			{
			    $digit = mt_rand(48, 122);
    			if (($digit>=58) and ($digit<=64)) $digit = 0;
    			if (($digit>=91) and ($digit<=96)) $digit = 0;
  			} while ($digit == 0);
  			$output .= chr($digit);
		}

		$this->values_key = $output;
	}
	
	public function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}
		$_SESSION["newpage_values_".$this->values_key."_".$pageedit["page_key"]] = $this->values;
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$setpath_str = "";
			if ($this->setpath)
			{
				$setpath_str = "&setpath=1";
			}
			?><a href="Javascript:openSmall2Dialog('<?php echo $page["page_path"]; ?>','newdata&newtemplate=<?php echo $this->template.$setpath_str; ?>&key=<?php echo $pageedit["page_key"]; ?>&random=<?php echo $this->values_key; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'New-Data-Editor');" onmouseout="return nd();"><img src='<?php echo $this->icon; ?>' alt='' border='0' class='oe_editbutton'/></a><?php
		}
	}
}

class PageOrderEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	private $pageedit;
	private $currentpage;
	public $tooltip;
	public $template;
	public $pagekey;
		
	function PageOrderEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$page;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->tooltip = "";
		$this->template = "";
		$this->pagekey = $page["page_key"];
		$this->pageedit = $page;
		$this->currentpage = $page;
	}
	
	function getEditor()
	{
		$sub = new Structure();
		$sub->key = $this->pagekey;
		if ($this->template != "")
		{
			$sub->template = $this->template;
		}
		$subpages = $sub->getStructure();
		if ((sizeof($subpages) > 1) && (!$this->output->isPreview()))
		{
			$subpage = $subpages[0];
			if ($this->user->pagePermission($this->pageedit["page_key"]))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_orderpage"] == 1))) 
				{
					$templateStr = "";
					if ($this->template != "")
					{
						$templateStr = "&template=".$this->template;
					}
	?><a href="Javascript:openNavigation('<?php echo $subpage["page_path"]; ?>','navigation&amp;redirect=<?php echo $this->currentpage["page_key"].$templateStr; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Navigation-Editor');" onmouseout="return nd();"><img src='system/img/oes_navigation.png' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			}
		}
	}
}

class IndividualEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $tooltip;
	var $include;
	var $name;
		
	function IndividualEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->tooltip = "";
		$this->include = "";
		$this->name = "Editor";
	}
	
	function getEditor()
	{
		global $page;
		if (!$this->output->isPreview())
		{
			if ($this->user->pagePermission($page["page_key"]))
			{
				?>
				<a href="Javascript:openBigDialog('<?php echo $page["page_path"]; ?>','edit/individual&include=<?php echo $this->include; ?>&name=<?php echo $this->name; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Individual-Editor');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a>
				<?
			}
		}
	}
}

class ModuleEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $block;
	var $tooltip;
	var $pagekey;
	var $adminLang;
	
	function ModuleEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openModuleeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Module-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
		}
	}
}

class AuthorizationEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	public $tooltip;
	public $pagekey;
	public $redirect;
	public $forsubpages;
	
	function AuthorizationEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$page;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->currentpage = $page;
		$this->redirect = $this->currentpage["page_key"];		
		$this->forsubpages = true;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
			{
				switch($pageedit["page_status"])
				{
					case 0:
					$icon = "oes_flag_green.png";
					break;
					case 1:
					$icon = "oes_flag_yellow.png";
					break;
					case 2:
					$icon = "oes_flag_red.png";
					break;
				}
				if ($this->forsubpages)
				{
					$forsub = "";
				}
				else 
				{
					$forsub = "&amp;forsub=0";
				}
				?><a href="Javascript:openAuthorization('<?php echo $pageedit["page_path"]; ?>','redirect=<?php echo $this->redirect.$forsub; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Authorization-Editor');" onmouseout="return nd();"><img src='system/img/<?php echo $icon; ?>' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?
			}
		}
	}
}

class IncludeEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $block;
	var $tooltip;
	var $returncontent;
	var $adminLang;
	
	function IncludeEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->returncontent = true;
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		$pageedit = $page;
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			?><a href="Javascript:openIncludeeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Include-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
			if ($this->returncontent) 
			{ 
				echo $this->output->outputInclude($this->block); 
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputInclude($this->block);
			}
		}
	}
}

class IframeEditor
{
	var $db;
	var $prefix;
	var $page;
	var $user;
	var $output;
	var $block;
	var $tooltip;
	var $returncontent;
	var $style;
	var $adminLang;
	
	function IframeEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->returncontent = true;
		$this->style = "";
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		$pageedit = $page;
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openIframeeditor('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'iFrame-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
			if ($this->returncontent) 
			{ 
				echo $this->output->outputIframe($this->block,$this->style);
			}
		}
		else
		{
			if ($this->returncontent) 
			{ 
				echo $this->output->outputIframe($this->block,$this->style);
			}
		}
	}
}

class UploadEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	public $block;
	public $tooltip;
	public $pagekey;
	private $adminLang;
	public $buttonstyle;
	
	function UploadEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->pagekey = 0;
		$this->adminLang = $admin_lang;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openUploadDialog('<?php echo $pageedit["page_path"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Upload-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_upload.png' width='16' height='16' alt='' border='0' <?php if ($this->buttonstyle != "") { echo "style='".$this->buttonstyle."'"; } else { echo "class='oe_editbutton'"; } ?>/></a><?php
		}
	}
}

class SelectEditor
{
	private $db;
	private $prefix;
	private $page;
	private $user;
	private $output;
	public $block;
	public $tooltip;
	public $selectarray;
	public $pagekey;
	private $adminLang;
	
	function SelectEditor()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_output,$admin_lang;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->output = $oe_output;
		$this->block = "page_text1";
		$this->tooltip = "";
		$this->selectarray = array();
		$this->adminLang = $admin_lang;
		$this->pagekey = 0;
	}
	
	function getEditor()
	{
		global $page;
		if ($this->pagekey != 0)
		{
			$pageedit = $this->page->getPageKey($this->pagekey);
		}
		else
		{
			$pageedit = $page;
		}	
		if ((!$this->output->isPreview()) && ($this->user->pagePermission($pageedit["page_key"])))
		{
			$selectstring = "option=";
			foreach ($this->selectarray as $value)
			{
				$selectstring .= $value["name"]."**";
				$selectstring .= $value["value"]."***";
			} 
			$redirect = $page["page_key"];
			if($this->page->isStage($pageedit["page_key"],$this->block))
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))
				{
					?><a href="Javascript:openRelease('<?php echo $pageedit["page_path"]; ?>','<?php echo $pageedit["page_key"]; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->adminLang["admin"]["23"]; ?>', CAPTION, '<?php echo $this->adminLang["admin"]["24"]; ?>');" onmouseout="return nd();"><img src='system/img/oes_release.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
				}
			} 
			?><a id="scroll<?php echo $this->block.$pageedit["page_key"]; ?>" href="Javascript:openSelecteditor('<?php echo $pageedit["page_path"]; ?>&<?php echo $selectstring; ?>','<?php echo $this->block; ?>&amp;redirect=<?php echo $redirect; ?>');" onmouseover="return overlib('<?php echo $this->tooltip; ?>', CAPTION, 'Select-Editor<?php if ($_SESSION["account_group"] == 2) { ?> [<?php echo $this->block; ?>]<? } ?>');" onmouseout="return nd();"><img src='system/img/oes_editor.png' width='16' height='16' alt='' border='0' class='oe_editbutton'/></a><?php
		}
	}
}
?>