<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Extranet
{
	var $db;
	var $set;
	var $prefix;
	var $session;
	
	public function Extranet()
	{
		global $oe_db,$oe_set,$db_praefix,$oe_session;
		$this->db = $oe_db;
		$this->set = $oe_set;
		$this->session = $oe_session;
		$this->prefix = $db_praefix;
	}
	
	public function init()
	{
		if (isset($_POST["extranet_action"]))
		{
			switch ($_POST["extranet_action"])
			{
				case "login":
				$this->login($_POST["extranet_email"],$_POST["extranet_password"]);
				break;
			}
		}	
	}
	
	public function isLoggedIn()
	{
		if ((isset($_SESSION["account_group"])) && ($_SESSION["account_group"] > 0))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function login($account_email,$account_password)
	{
		global $page;
		$account_password = md5($account_password);	
		$param = array("account_email" => $account_email, "account_password" => $account_password);
		$query = "SELECT * FROM ".$this->prefix."account WHERE (account_email = :account_email) AND (account_password = :account_password) AND (account_lock = 0)";
		$resArr = $this->db->row($query,$param);
		if (sizeof($resArr) > 1)
		{
			session_regenerate_id();			
			$resArr = $this->db->row($query,$param);
			foreach (array_keys($resArr) as $value)
			{
				$_SESSION[$value] = $resArr[$value];
			}
			if (isset($_POST["account_save_cookie"]))
			{
				setcookie("account_email",$account_email,time() + 60*60*24*365);
				setcookie("account_password",$account_password,time() + 60*60*24*365);
				setcookie("cookie_login","true",time() + 60*60*24*365);
			}
			if ($_SESSION["account_group"] > 1)
			{
				$_SESSION["preview"] = 0;
				$this->session->setOeCookie($_SESSION["account_randomkey"]);
				$_SESSION["account_group"] = 1;
			}
			?>
            <script type="text/javascript">
			location.href = "website.php?id=<?= $page["page_path"]; ?>";
			</script>
            <?
		}
	}

	public function loginCookie()
	{
		global $page;
		if ((isset($_SESSION["account_group"])) && ($_SESSION["account_group"] == 0))
		{
			if ((isset($_COOKIE["account_email"])) && ($_COOKIE["account_email"] != "") && (isset($_COOKIE["account_password"])) && ($_COOKIE["account_password"] != ""))
			{
				$account_email = $_COOKIE["account_email"];
				$account_password = $_COOKIE["account_password"];	
				$param = array("account_email" => $account_email, "account_password" => $account_password);
				$query = "SELECT * FROM ".$this->prefix."account WHERE (account_email = :account_email) AND (account_password = :account_password) AND (account_lock = 0)";
				$resArr = $this->db->row($query,$param);
				if (sizeof($resArr) > 1)
				{
					session_regenerate_id();			
					$resArr = $this->db->row($query,$param);
					foreach (array_keys($resArr) as $value)
					{
						$_SESSION[$value] = $resArr[$value];
					}
					if ($_SESSION["account_group"] > 1)
					{
						$_SESSION["preview"] = 1;
						$this->session->setOeCookie($_SESSION["account_randomkey"]);
						?>
                <script type="text/javascript">
				location.href = "website.php?id=<?= $page["page_path"]; ?>";
				</script>
						<?php
					}					
				}
			}
		}
	}
		
	public function logout()
	{
		global $page;
		session_unset();
		session_destroy();
		$_SESSION["account_group"] = 0;
		setcookie("account_email","",time() - 60*60*24);
		setcookie("account_password","",time() - 60*60*24);
		setcookie("cookie_login","",time() - 60*60*24);		
		?>
        <script type="text/javascript">
		location.href = "website.php?id=<?= $page["page_path"]; ?>";
		</script>
		<?php
	}
	
	public function getUserDataKey($user_key)
	{
		$param = array("user_key" => $user_key);
		$query = "SELECT * FROM ".$this->prefix."extranet_user WHERE user_key = :user_key";
		return $this->db->row($query,$param);
	}

	public function getUserDataEmail($user_email)
	{
		$param = array("user_key" => $user_key);
		$query = "SELECT * FROM ".$this->prefix."extranet_user WHERE user_email = :user_email";
		return $this->db->row($query,$param);
	}
}	
?>