<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Frontend
{
	private $db;
	private $page;
	private $set;
	private $prefix;
		
	public function Frontend()
	{
		global $oe_db,$oe_page,$oe_set,$db_praefix;
		$this->db = $oe_db;
		$this->page = $oe_page;
		$this->set = $oe_set;
		$this->prefix = $db_praefix;
	}
	
	public function writeOk($link)
	{
		echo '<input id="oe_btn_ok" type="button" value="Ok" class="adminsubmitbtn" onclick="'.$link.'">';
	}

	public function writeOkExport($link)
	{
		echo '<input id="oe_btn_ok" type="button" value="Ok/Export" class="adminsubmitbtn" onclick="'.$link.'">';
	}

	public function writeCancel($link)
	{
		if ($_SESSION["account_lang"] == "de")
		{
			$button_text = "Abbrechen";
		}
		else
		{
			$button_text = "Cancel";
		}
		echo '<input id="oe_btn_cancel" type="button" value="'.$button_text.'" class="adminsubmitbtn" onclick="window.close()" />';
	}	
	
	public function writeUpdate($link)
	{
		if ($_SESSION["account_lang"] == "de")
		{
			$button_text = "Speichern";
		}
		else
		{
			$button_text = "Save";
		}
		echo '<input type="button" value="'.$button_text.'" class="adminsubmitbtn" onclick="'.$link.'">';
	}	
	
	public function writeBack($link)
	{
		if ($_SESSION["account_lang"] == "de")
		{
			$button_text = "Zur&uuml;ck";
		}
		else
		{
			$button_text = "Back";
		}
		echo '<input type="button" value="'.$button_text.'" class="adminsubmitbtn" onclick="'.$link.'">';
	}

	public function resetMenu()
	{
		$param = array("account_menux" => "3","account_menuy" => "25","account_key" => $_SESSION["account_key"]);
		$query = "UPDATE ".$this->prefix."account SET account_menux = :account_menux, account_menuy = :account_menuy WHERE account_key = :account_key";
		$_SESSION["account_menux"] = 3;
		$_SESSION["account_menuy"] = 25;
		$this->db->update($query,$param);
	}
		
	public function getAdminHead($name,$img,$control = "")
	{
		global $admin_lang,$page;
		if ($control == "yes") 
		{ 
		?>
		<link rel="stylesheet" type="text/css" href="system/style/oe_pullmenu.css" />
		<script type="text/javascript" src="system/script/DropDownMenuX.js"></script>
		<div id="oe_menuback"></div>
		<div id="oe_pulldown">
		<table cellspacing="0" cellpadding="0" id="menu1" class="ddmx">
			<tr>
				<td>
					<a class="item1" href="javascript:void(0)">System</a>
					<div class="section">
						<a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=settings"><?php echo $admin_lang["settings"][1]; ?></a>
						<a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=files"><?php echo $admin_lang["files"][1]; ?></a>
						<a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=stringpool"><?php echo $admin_lang["stringpool"][1]; ?></a>
						<a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=languages"><?php echo $admin_lang["lang"][1]; ?></a>
					</div>
				</td>
		        <td>
					<a class="item1" href="javascript:void(0)">Layout</a>
					<div class="section">
						<a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=templates"><?php echo $admin_lang["templates"][1]; ?></a>
		                <a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=attributes"><?php echo $admin_lang["attributes"][1]; ?></a>
		                <a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=edit/css">Editor CSS</a>
		            </div>
		        </td>
		        <td>
		            <a class="item1" href="javascript:void(0)"><?php echo $admin_lang["admin"][5]; ?></a>
		            <div class="section">
		                <a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=accounts"><?php echo $admin_lang["accounts"][1]; ?></a>
		                <a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=statistic"><?php echo $admin_lang["statistics"][1]; ?></a>
		                <a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=group"><?php echo $admin_lang["group"][1]; ?></a>
		            </div>
		        </td>
		        <td>
		            <a class="item1" href="javascript:void(0)"><?php echo $admin_lang["admin"][6]; ?></a>
		            <div class="section">
		                <a class="item2" href="website.php?id=<?php echo $page["page_path"]; ?>&admin=replacing"><?php echo $admin_lang["replacing"][1]; ?></a>
		            </div>
		        </td>
		        <td>
		            <a class="item1" href="javascript:void(0)"><?php echo $admin_lang["admin"][7]; ?></a>
		            <div class="section">
		                <a class="item2" href="<?php echo $this->set->getSiteHelp(); ?>" target="_blank"><?php echo $admin_lang["admin"][2]; ?></a>
		                <a class="item2" href="http://www.openengine.de" target="_blank">openengine.de</a>
		                <a class="item2" href="http://www.openengine.de/forum" target="_blank">Forum</a>
		            </div>
		        </td>
		    </tr>
		    </table>
		</div>
		<script type="text/javascript">
		var ddmx = new DropDownMenuX('menu1');
		ddmx.delay.show = 0;
		ddmx.delay.hide = 400;
		ddmx.position.levelX.left = 2;
		ddmx.init();
		</script>
		<?php } ?>
		<!-- Admin Head START -->
		<div id="oe_head">
		<div class="icon"><img src="system/img/oes_<?php echo $img; ?>.png" width="16" height="16" alt="" border="0"></div>
		<div class="text"><?php echo $name; ?></div>
		</div>
		<!-- Admin Head END -->
		<?php
	}

	public function writeHtmlHead()
	{
		global $site_encoding;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<?
		$site_enc = "utf-8";
		if ($site_encoding != "noencoding")
		{
			$site_enc = $site_encoding;
		}
?>
<head>
<title><?= $this->set->getSystemShort(); ?></title>
<!--[if lte IE 7]>
<script src="system/script/IE7/ie7-standard-p.js" type="text/javascript"></script>
<![endif]-->
<meta http-equiv="content-type" content="text/html; charset=<?= $site_enc; ?>">
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="Cache-Control" content="no-cache"> 
<script src="system/scriptaculous/lib/prototype.js" type="text/javascript"></script>
<script src="system/scriptaculous/src/scriptaculous.js?load=effects,dragdrop" type="text/javascript"></script>
<? if ((isset($_GET["admin"])) && ($_GET["admin"] == "edit/text")) {} else { ?>
<script type="text/javascript" src="system/script/overlib/overlib.js"><!-- overLIB (c) Erik Bosrup --></script>
<link rel="stylesheet" href="system/style/oe_tooltip.css" type="text/css" media="screen" />
<? } ?>
<? if ((isset($_GET["admin"])) && ($_GET["admin"] == "filepool")) { ?>
<script language="JavaScript" src="system/script/tablesort_v2.js" type="text/javascript"></script>
<? } ?>
<link rel="stylesheet" href="system/script/tabs/css/tab-view.css" type="text/css" media="screen">
<script type="text/javascript" src="system/script/tabs/js/tab-view.js"></script>
<script type="text/javascript" language="JavaScript" src="system/script/oe_cookie.js"></script>
<script type="text/javascript" language="JavaScript" src="system/script/oe_dialog.js"></script>
<link rel="stylesheet" href="system/style/oe_style.css" type="text/css" media="screen">
<link rel="stylesheet" href="system/themes/<?= $this->set->getSystemTheme(); ?>/style.css" type="text/css" media="screen">
<? if ((isset($_GET["admin"])) && ($_GET["admin"] == "properties")) { ?>
<script type="text/javascript" src="system/script/oe_modal.js"></script>
<? } ?>
<script type="text/javascript" src="system/script/oe_modal.js"></script>
</head>
<body>
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1005;"></div>
<?		
	}
	
	public function writeHtmlBottom()
	{
?>
</body>
</html>
<?
	}
}
?>