<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Output
{
	var $db;
	var $page;
	var $user;
	var $nav;
	var $mod_db_written;
	var $mod_file_written;
	var $mod_stringpool_written;
	var $prefix;
	var $set;
	
	function Output()
	{
		global $oe_db,$oe_page,$oe_user,$oe_nav,$db_praefix,$oe_set;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->nav = $oe_nav;
		$this->set = $oe_set;
		$this->mod_db_written = false;
		$this->mod_file_written = false;
		$this->mod_stringpool_written = false;
	}
	
	function isPreview()
	{
		if ((isset($_SESSION["preview"])) && ($_SESSION["preview"] == 1))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function outputBlock($block,$subpage = 0)
	{
		global $page;
		
		$pageedit = $this->getEditContent($page,$subpage);
		
		if ($this->user->pagePermission($pageedit["page_key"]))
		{
			if ($this->set->getSiteStaging() == 0)
			{
				$output = $pageedit[$block];
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$block))
				{
					$output = $this->page->stagingOutput($block,$subpage);
				}
				else
				{
					$output = $pageedit[$block];
				}
			}
		}
		else
		{
			$output = $pageedit[$block];
		}
		return $output;
	}

	function outputInclude($block)
	{
		global $page;
		$pageedit = $page;
		$path_inc = "";
		
		if ($this->user->pagePermission($pageedit["page_key"]))
		{
			if ($this->set->getSiteStaging() == 0)
			{
				$path_inc = $pageedit[$block];
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$block))
				{
					$path_inc = $this->page->stagingOutput($block);
				}
				else
				{
					$path_inc = $pageedit[$block];
				}
			}
		}
		else
		{
			$path_inc = $pageedit[$block];
		}
		$content = "";
		if ($path_inc != "")
		{
			$fp = fopen($path_inc, "r");
			if ($fp)
			{
				while(!feof($fp))
				{
					$content .= fread($fp,"10000");
				}
				fclose($fp);
			}
		}
		return $content;
	}

	function outputIframe($block,$style)
	{
		global $page;
		$pageedit = $page;
		$path_inc = "";
		
		if ($this->user->pagePermission($pageedit["page_key"]))
		{
			if ($this->set->getSiteStaging() == 0)
			{
				$path_inc = $pageedit[$block];
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$block))
				{
					$path_inc = $this->page->stagingOutput($block);
				}
				else
				{
					$path_inc = $pageedit[$block];
				}
			}
		}
		else
		{
			$path_inc = $pageedit[$block];
		}
		$content = "";
		if ($path_inc != "")
		{
			$content .= '<iframe src="'.$path_inc.'" style="'.$style.'" frameborder="0"></iframe>';
		}
		return $content;
	}

	function outputModule($block,$static_path = "",$subpage = 0)
	{
		global $page;
		$pageedit = $this->getEditContent($page,$subpage);
		if ($this->user->pagePermission($pageedit["page_key"]))
		{
			if ($this->set->getSiteStaging() == 0)
			{
				$output = $pageedit[$block];
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$block))
				{
					$output = $this->page->stagingOutput($block);
				}
				else
				{
					$output = $pageedit[$block];
				}
			}
		}
		else
		{
			$output = $pageedit[$block];
		}
		$this->includeModule($output,$static_path);
	}	
	
	function includeModule($output,$static_path = "")
	{	
		global $page,$db_server,$db_user,$db_password,$db_name,$lang_input;
		$module_path = $this->set->getModulePath();
		$this_module_path = $module_path.$output;
		$lang_input_page = $page["page_lang"];
		if ($output != "")
		{
			$mod_mode = 1;
			include($module_path.$output."/description.php");
			if (isset($_GET["export"]))
			{
				if ($mod_mode == 1)
				{
					include($module_path.$output."/main.php");
				}
				elseif ($mod_mode == 2)
				{
					echo file_get_contents($module_path.$output."/description.php");
					echo "<? \n";
					echo '$this_module_path = "'.$static_path.$output.'";'."\n";
					echo '$lang_input = "'.$lang_input.'";'."\n";
					echo '$lang_input_page = "'.$lang_input_page.'";'."\n";
					echo '$site_admin = "'.$this->set->getSiteAdmin().'";'."\n";
					echo '$site_name = "'.$this->set->getSiteName().'";'."\n";
					echo 'function isAdmin() { return false; }'."\n";
					echo "?>";
					if ((isset($this->mod_useInternalDB)) && ($this->mod_useInternalDB) && (!$this->mod_db_written))
					{
						echo "<? \n";
						echo '$db_server = "'.$db_server.'";'."\n";
						echo '$db_user = "'.$db_user.'";'."\n";
						echo '$db_password = "'.$db_password.'";'."\n";
						echo '$db_name = "'.$db_name.'";'."\n";
						echo '$this->prefix = "'.$this->prefix.'";'."\n";
						echo "\n";
						echo 'function connectDB()'."\n";
						echo '{'."\n";				
						echo '	global $db_server, $db_user, $db_password, $db_name;'."\n";
						echo '	$link = mysql_pconnect($db_server, $db_user, $db_password);'."\n";
						echo '	mysql_select_db($db_name);'."\n";
						echo '	return $link;'."\n";
						echo '}'."\n";
						echo "\n";
						echo 'function closeDB($link)'."\n";
						echo '{'."\n";
						echo '	mysql_close($link);'."\n";
						echo '}'."\n";
						echo "?>";
						$this->mod_db_written = true;
					}
					if ((isset($this->mod_writeStringpool)) && ($this->mod_writeStringpool) && (!$this->mod_stringpool_written))
					{
						echo "<? \n";
						$query = "SELECT * FROM ".$this->prefix."stringpool";
						$resArr = $this->db->select($query);
						foreach ($resArr as $row)
						{
							echo '$stringpool_arr["'.$row["str_name"].'"]["'.$row["str_select"].'"] = "'.$row["str_value"].'";'."\n";
						}
						echo 'function stringpool($str_key,$str_val)'."\n";
						echo '{'."\n";
						echo '	global $stringpool_arr;'."\n";
						echo '	return $stringpool_arr[$str_key][$str_val];'."\n";
						echo '}'."\n";
						echo "?>";
						$this->mod_stringpool_written = true;
					}				
					if (!$this->mod_file_written)
					{
						echo "<? \n";
						echo 'function translatePath($page_file)'."\n";
						echo '{'."\n";
						echo '	$file_name = str_replace("/", "_", $page_file);'."\n";
						echo '	if (substr($file_name, 0, 1) == "_")'."\n";
						echo '	{'."\n";
						echo '		$file_name = substr($file_name, 1);'."\n";
						echo '	}'."\n";
						echo '	return $file_name;'."\n";
						echo '}'."\n";
						echo "?>";
						$this->mod_file_written = true;
					}
					echo file_get_contents($module_path.$output."/main.php");
				}
			}
			else
			{
				include($module_path.$output."/main.php");
			}
		}
	}
	
	function isContent($block,$subpage = 0)
	{
		global $page;
		
		$pageedit = $this->getEditContent($page,$subpage);
		if ($this->set->getSiteStaging() == 0)
		{
			if ($pageedit[$block] == "")
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		else
		{
			if($this->page->isStage($pageedit["page_key"],$block))
			{
				$output = $this->page->stagingOutput($block,$subpage);
			}
			else
			{
				$output = $pageedit[$block];
			}
			if ($output == "")
			{
				return false;
			}
			else
			{
				return true;
			}
		}
	}

	function outputAlttext($block,$subpage = 0)
	{
		global $page;
		
		$pageedit = $this->getEditContent($page,$subpage);
		
		if ($this->user->pagePermission($pageedit["page_key"]))
		{
			if ($this->set->getSiteStaging() == 0)
			{
				$output = $pageedit[$block];
			}
			else
			{
				if($this->page->isStage($pageedit["page_key"],$block))
				{
					$output = $this->page->stagingOutput($block,$subpage);
				}
				else
				{
					$output = $pageedit[$block];
				}
			}
		}
		else
		{
			$output = $pageedit[$block];
		}
		$param = array("asset_filename" => $output);
		$query = "SELECT * from ".$this->prefix."asset WHERE asset_filename = :asset_filename";
		$altArr = $this->db->row($query,$param);
		return $altArr["asset_alt"];
	}

	function outputSelect($block,$select,$subpage = 0)
	{
		global $page;
		$input = "";
		$emptyOutput = 0;
		
		$pageedit = $this->getEditContent($page,$subpage);
		
		if ($this->outputBlock($block,$pageedit["page_key"]) == "")
		{
			$emptyOutput = 1;
		}
		
		if ($emptyOutput == 0)
		{
			$input = $this->outputBlock($block,$pageedit["page_key"]);
		
			foreach ($select as $value)
			{
				if ($value["value"] == $input)
				{
					echo $value["name"];
				}
			} 
		}
		else
		{
			echo $select[0]["name"];
		}
	}	

	function getEditContent($page,$subpage)
	{
		if ($subpage != 0)
		{
			return $this->page->getPageKey($subpage);
		}
		else
		{
			return $page;
		}	
	}
}
?>