<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Password
{
	var $set;
	
	/**
	 * Konstruktor
	 *
	 * @return Password
	 */
	public function Password()
	{
		global $oe_set;
		$this->set = $oe_set;
	}
	
	/**
	 * Prft die Komplexitt eines Passworts.
	 *
	 * @param string $password Passwort
	 * @return bool 	false: Passwort nicht komplex
	 * 					true: Passwort komplex  
	 */
	public function checkComplexity($password)
	{
		if ($this->set->checkPasswordComplexity())
		{
			$complexity = 0;
			$pass_low = strtolower($password);
			$pass_high = strtoupper($password);
			if (($pass_low != $password) && ($pass_high != $password))
			{
				$complexity++;
			}
			$reg1 = "/[0-9]{1}/";
			$reg2 = "/[a-zA-Z]{1}/";
			if ((preg_match($reg1,$password)) && (preg_match($reg2,$password)))
			{
				$complexity++;
			}
			$reg = "/[^a-zA-Z0-9]{1}/";
			if (preg_match($reg,$password))
			{
				$complexity++;
			}
			if ($complexity > 1)
			{
				return true;
			}	
			else 
			{
				return false;				
			}
		}
		else 
		{
			return true;
		}
	}
	
	/**
	 * Prft die Passwort-Lnge.
	 *
	 * @param string $password Passwort
	 * @return bool		false: Passwort ist nicht lang genug
	 * 					true: Passwort ist lang genug
	 */
	public function checkLength($password)
	{
		if (strlen($password) >= $this->set->getPasswordLength())
		{
			return true;
		}
		else 
		{
			return false;
		}
	}
}
?>