<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Path
{
	var $page;
	var $db;
	var $prefix;
	
	/**
	 * Konstruktor
	 *
	 * @return Path
	 */
	public function Path()
	{
		global $oe_page,$oe_db,$db_praefix;
		$this->page = $oe_page;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
	}
	
	/**
	 * Prft den eingegebenen Pfad
	 *
	 * @param string $page_path
	 * @return int
	 */
	public function checkPath($page_path)
	{
		if ($page_path != "")
		{
			$page_path = strip_tags($page_path);
			$page_path = str_replace(" ","",$page_path);
			$page_path = $this->page->htmlEncode($page_path);
			$page_path = str_replace(";","",$page_path);
			$page_path = str_replace("&","",$page_path);
			$page_path = str_replace("../","",$page_path);
			$page_path = str_replace("./","",$page_path);
			$page_path_str = substr($page_path,0,1);
			if ($page_path_str != "/")
			{
				$page_path = "/".$page_path;
			}		
			$param = array("page_path" => $page_path);
			$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_path = :page_path";
			return $this->db->count($query,$param);
		}
		else 
		{
			return 1;
		}
	}
}
?>