<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Properties
{
	private $set;
	private $account_group;
	
	public function Properties()
	{
		global $oe_set;
		$this->set = $oe_set;
		$this->account_group = $_SESSION["account_group"];
	}
	
	public function getFiletypeList($current = "")
	{
		$ret = array();
		$default_type = $this->set->getDefaultFiletype();
		$item = array();
		$item["type"] = $default_type;
		$item["active"] = 1;
		if ($default_type != $current)
		{
			$item["active"] = 0;
		}
		array_push($ret,$item);				
		if ($this->account_group == 2)
		{
			$list = $this->set->getAdminTypes();
		}
		else
		{
			$list = $this->set->getAuthorTypes();
		}
		foreach (explode(",",$list) as $value)
		{
			if ($value != $default_type)
			{
				$item = array();
				$item["type"] = trim($value);
				if ($value == $current)
				{
					$item["active"] = 1;
				}
				else
				{
					$item["active"] = 0;
				}
				array_push($ret,$item);
			}
		}
		return $ret;				
	}
	
	public function getFiletype($path)
	{
		$arr = explode(".",$path);
		$arr = array_reverse($arr);
		return ".".$arr[0];
	}
	
	public function getPathonly($path)
	{
		return str_replace($this->getFiletype($path),"",$path);
	}
	
	public function checkPath($path)
	{
		if ($this->account_group == 2)
		{
			$list = $this->set->getAdminTypes();
		}
		else
		{
			$list = $this->set->getAuthorTypes();
		}
		$type = $this->getFiletype($path);
		$arr = explode(",",$list);
		$pos = array_search($type,$arr);
		if ($pos === false)
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}
?>