<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Sitestructure
{
	var $db;
	var $prefix;
	var $page;
	var $user; 
	var $dialog;
	var $adminLang;
	var $subArr;
	var $nav;
	var $set;
	
	public function Sitestructure()
	{
		global $oe_db,$db_praefix,$oe_page,$oe_user,$oe_dialog,$admin_lang,$oe_nav,$oe_set;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->page = $oe_page;
		$this->user = $oe_user;
		$this->dialog = $oe_dialog;
		$this->nav = $oe_nav;
		$this->set = $oe_set;
		$this->adminLang = $admin_lang;
		$this->subArr = array();
	}

	public function loadTree()
	{
		global $site_encoding,$page;
		$structure_block = $this->set->getStructureBlock();
		$parent = $_POST["parent"];
		$pagePath = 0;
		if (isset($_POST["path"]))
		{
			$pagePath = $_POST["path"];
		}
		if ($parent == 0)
		{
			$param = array("page_parent" => $parent);
			$query = "SELECT page_key,page_path,page_status,page_main,treelink_key,page_forceexport,page_lockexport,page_title,page_headline,page_navigation,page_extern FROM ".$this->prefix."page WHERE page_parent = :page_parent ORDER BY ".$structure_block;
			$resArr = $this->db->select($query,$param);
			foreach($resArr as $row) 
			{ 
				if ($row["page_status"] == 0)
				{
					$img = "oes_flag_green.png";
				}
				else if ($row["page_status"] == 1)
				{
					$img = "oes_flag_yellow.png";
				}
				else
				{
					$img = "oes_flag_red.png";
				}
				$perm = 1;
				if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 3))
				{
					if (!$this->user->pagePermission($row["page_key"]))
					{
						$img = 'oes_lock.png';	
						$perm = 0;					
					}
				}
				$perm_img = '';
				if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 2))
				{
					$param = array("page_key" => $row["page_key"]);
					$query = "SELECT perm_key,perm_type FROM ".$this->prefix."permission WHERE page_key = :page_key";
					$permArr = $this->db->row($query,$param);
					if (sizeof($permArr) > 1)
					{
						if ($permArr["perm_type"] == 0)
						{
							$perm_img = '<img src="system/img/oes_permission_add.png">';
						}
						if ($permArr["perm_type"] == 1)
						{
							$perm_img = '<img src="system/img/oes_permission_delete.png">';
						}
					}
				}
				?>
				<div class="folder_cont" id="folder_cont_<?= $row["page_key"]; ?>">
				<div class="folder_name" id="folder_name_<?= $row["page_key"]; ?>" onmouseover="borderOn(<?= $row["page_key"]; ?>)" onmouseout="borderOff(<?= $row["page_key"]; ?>)" ondblclick="loadTree(<?= $row["page_key"]; ?>)" onclick="activeFolder(<?= $row["page_key"]; ?>)">
				<table><tr valign="top"><td>
				<?
				$sub = new Structure();
				$sub->key = $row["page_key"];
				$sub->navigation = true;
				$subpages = $sub->getStructure();
				if (sizeof($subpages) > 0)
				{
				?>
				<div class="folder_arrow" onclick="loadTree(<?= $row["page_key"]; ?>)" id="arrow_<?= $row["page_key"]; ?>"><img src="system/img/collapsed.png" id="plus_<?= $row["page_key"]; ?>"></div>
				<?
				}
				else
				{
				?>
				<div class="folder_arrow" id="arrow_<?= $row["page_key"]; ?>"><img src="system/img/blank.gif" width="16" height="16" id="plus_<?= $row["page_key"]; ?>"></div>
				<?
				}
				?>
				</td>
				<? if ($img == "oes_trash.png") { ?>
				<td onclick="loadMenu(<?= $row["page_key"]; ?>)" class="folder_td" title="<?= $this->adminLang["admin"][19]; ?>"><img src="system/img/<?= $img; ?>"></td>
				<div class="folder_image_menu" id="folder_image_menu_<?= $row["page_key"]; ?>" style="display:none;">
				<a href="Javascript:hideMenu();" class="context_title"><?= $this->adminLang["filepool"][43]; ?></a>
				<a href="Javascript:restorePage();" style="background-image:url(system/img/oes_restore.png);"><?= $this->adminLang["structure"][22]; ?></a>
				<a href="Javascript:deleteStartsite();" style="background-image:url(system/img/oes_pagedelete.png);"><?= $this->adminLang["structure"][29]; ?></a>
				<a href="Javascript:cutFolder();" style="background-image:url(system/img/oes_cut.png);"><?= $this->adminLang["structure"][1]; ?></a>
				</div>
				<? } elseif (($img == "oes_flag_green.png") || ($img == "oes_flag_yellow.png") || ($img == "oes_flag_red.png")) { ?>
				<? if ($_SESSION["account_group"] == 3) { ?>
				<td class="folder_td"><img src="system/img/<?= $img; ?>"></td>
				<div id="folder_image_menu_<?= $row["page_key"]; ?>"></div>
				<? } else { ?>
				<td onclick="loadMenu(<?= $row["page_key"]; ?>)" class="folder_td" style="background-image:url(system/img/<?= $img; ?>);" title="<?= $this->adminLang["admin"][19]; ?>"><img src="system/img/<?= $img; ?>"></td>
				<div class="folder_image_menu" id="folder_image_menu_<?= $row["page_key"]; ?>" style="display:none;">
				<a href="Javascript:hideMenu();" class="context_title"><?= $this->adminLang["filepool"][43]; ?></a>
				<? if ($_SESSION["account_group"] == 2) { ?>
				<a href="Javascript:editStartsite();" style="background-image:url(system/img/oes_editstartsite.png);"><?= $this->adminLang["structure"][10]; ?></a>
				<a href="Javascript:copyStartsite();" style="background-image:url(system/img/oes_copy.png);"><?= $this->adminLang["structure"][31]; ?></a>
				<a href="Javascript:deleteStartsite();" style="background-image:url(system/img/oes_pagedelete.png);"><?= $this->adminLang["structure"][29]; ?></a>
				<a href="Javascript:forceExport();" style="background-image:url(system/img/oes_export.png);"><?= $this->adminLang["structure"][21]; ?></a>
				<? if ($this->set->getPagePermission() == 1) { ?>
				<a href="Javascript:editPermission();" style="background-image:url(system/img/oes_permission_add.png);"><?= $this->adminLang["structure"][15]; ?></a>
				<? } ?>
				<? } ?>
				<? if (($this->set->getSiteStaging() == 1) && (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))) { ?>
				<a href="Javascript:releaseContent();" style="background-image:url(system/img/oes_release.png);"><?= $this->adminLang["structure"][46]; ?></a>
				<? } ?>
				<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_treelink"] == 1))) { ?>
				<a href="Javascript:treeLink();" style="background-image:url(system/img/oes_treelink.png);"><?= $this->adminLang["structure"][41]; ?></a>
				<? } ?>
				<? if ($_SESSION["account_group"] == 2) { ?>
				<a href="Javascript:openToolbox();" style="background-image:url(system/img/oes_dump.png);">Toolbox/Information</a>
				<? } ?>
				</div>
				<? }} else { ?>
				<td class="folder_td"><img src="system/img/<?= $img; ?>"></td>
				<div id="folder_image_menu_<?= $row["page_key"]; ?>"></div>
				<? } ?>
				</div>
				<? if ($row["page_main"] == 1) { ?>
				<td><img src="system/img/oes_pagestart_main.png"></td>
				<? } else { ?>
				<td><img src="system/img/oes_pagestart.png"></td>
				<? } ?>
				<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_treelink"] == 1))) { ?>
				<? if ($row["treelink_key"] != 0) { ?>
				<td id="treelink_<?= $row["page_key"]; ?>"><a href="Javascript:treeLink();"><img src="system/img/oes_treelink.png"></a></td>
				<? } else { ?>
				<td id="treelink_<?= $row["page_key"]; ?>" style="display:none;"><a href="Javascript:treeLink();"><img src="system/img/oes_treelink.png"></a></td>
				<? } ?>
				<? } else { ?>
				<? if ($row["treelink_key"] != 0) { ?>
				<td id="treelink_<?= $row["page_key"]; ?>"><img src="system/img/oes_treelink.png"></td>
				<? } else { ?>
				<td id="treelink_<?= $row["page_key"]; ?>" style="display:none;"><img src="system/img/oes_treelink.png"></td>
				<? } ?>
				<? } ?>
				<? if ($perm_img != "") { ?>
				<? if ($perm_img == '<img src="system/img/oes_permission_add.png">') { ?>
				<td><a href="Javascript:editPermission();"><?= $perm_img; ?></a></td>
				<? } else { ?>
				<td><a href="Javascript:editforPermission();"><?= $perm_img; ?></a></td>
				<? } ?>
				<? } ?>
				<? if (($row["page_forceexport"] == 1) && ($row["page_lockexport"] == 0) && ($_SESSION["account_group"] == 2)) { ?>
				<td><a href="Javascript:forceExport();"><img src="system/img/oes_export.png"></a></td>
				<? } elseif (($row["page_lockexport"] == 1) && ($_SESSION["account_group"] == 2)) { ?>
				<td><a href="Javascript:forceExport();"><img src="system/img/oes_exportlock.png"></a></td>
				<? } ?>
				<td><div class="folder_text" id="text_<?= $row["page_key"]; ?>"><a href="#" id="name_<?= $row["page_key"]; ?>"><? if ($site_encoding == "utf-8") { echo $row[$structure_block]; } else { echo utf8_decode($row[$structure_block]); } ?></a><? if ($row["page_extern"] != "") { ?><a href="<?= $row["page_extern"]; ?>" target="_blank">[<?= substr($row["page_extern"],0,40); ?><? if (strlen($row["page_extern"]) >= 40) { echo "..."; } ?>]</a><? } ?></div></td></tr></table>
				</div><div class="folder_subtree" id="folder_subtree_<?= $row["page_key"]; ?>"><?
				$pArr = explode(",",$pagePath); 
				if (($pagePath != "0") && ($row["page_key"] == $pArr[1]))
				{
					$this->writePath($pArr,1);
				} 
				?></div></div>
				<input type="hidden" id="startsite_<?= $row["page_key"]; ?>" value="1">
				<input type="hidden" id="path_<?= $row["page_key"]; ?>" value="<?= $row["page_path"]; ?>">
				<input type="hidden" id="perm_<?= $row["page_key"]; ?>" value="<?= $perm; ?>">
				<? 					
			}
			if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_filepool"] == 1))) 
			{
		?>
		<? if ((isset($_GET["selector"])) && (($_GET["selector"] == 1) || ($_GET["selector"] == 3))) { ?>
		<div class="folder_cont" id="folder_cont_-10">
		<div class="folder_name" id="folder_name_-10" onmouseover="borderOn(-10)" onmouseout="borderOff(-10)">
		<table><tr valign="top"><td><div class="folder_arrow"><img src="system/img/collapsed.png"></div></td>
		<td><img src="system/img/oes_pool.png"></td>
		<div id="folder_image_menu_-10"></div>
		<td><div class="folder_text" onclick="location.href='website.php?id=<?= $page["page_path"] ?>&admin=filepool&selector=<?= $_GET["selector"]; ?>&link=1&filter=all&field_name=href'"><a href="#" id="name_<?= $row["page_key"]; ?>">FilePool</a></div></td>
		</tr></table>
		</div>
		</div>
		<? } ?>
		<?
			}
		}
		else
		{
			$param = array("page_parent" => $parent);
			$query = "SELECT page_key,page_path,page_status,page_main,treelink_key,page_forceexport,page_lockexport,page_title,page_navigation,page_headline,page_extern FROM ".$this->prefix."page WHERE page_parent = :page_parent ORDER BY page_order desc";
			$resArr = $this->db->select($query,$param);
			foreach($resArr as $row) 
			{ 
				if ($row["page_status"] == 0)
				{
					$img = "oes_flag_green.png";
				}
				else if ($row["page_status"] == 1)
				{
					$img = "oes_flag_yellow.png";
				}
				else if ($row["page_status"] == 2)
				{
					$img = "oes_flag_red.png";
				}
				else
				{
					$img = "oes_trash.png";
				}
				$perm = 1;
				if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 3))
				{
					if (!$this->user->pagePermission($row["page_key"]))
					{
						$img = 'oes_lock.png';
						$perm = 0;						
					}
				}
				$perm_img = '';
				if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 2))
				{
					$param = array("page_key" => $row["page_key"]);
					$query = "SELECT perm_key,perm_type FROM ".$this->prefix."permission WHERE page_key = :page_key";
					$permArr = $this->db->row($query,$param);
					if (sizeof($permArr) > 1)
					{
						if ($permArr["perm_type"] == 0)
						{
							$perm_img = '<img src="system/img/oes_permission_add.png">';
						}
						if ($permArr["perm_type"] == 1)
						{
							$perm_img = '<img src="system/img/oes_permission_delete.png">';
						}
					}
				}
				$rss_img = '';
				if ($_SESSION["account_group"] == 2)
				{
					$param = array("page_key" => $row["page_key"]);
					$query = "SELECT * FROM ".$this->prefix."rss WHERE page_key = :page_key";
					$resArr = $this->db->row($query,$param);
					if (sizeof($resArr) > 1)
					{
						$rss_img = '<img src="system/img/oes_rss.png">';
					}
				}
				if (($img != 'oes_lock.png') || ($row["page_status"] != 3))
				{
				?>
				<div class="folder_cont" id="folder_cont_<?= $row["page_key"]; ?>">
				<div class="folder_name" id="folder_name_<?= $row["page_key"]; ?>" onmouseover="borderOn(<?= $row["page_key"]; ?>)" onmouseout="borderOff(<?= $row["page_key"]; ?>)" ondblclick="loadTree(<?= $row["page_key"]; ?>)" onclick="activeFolder(<?= $row["page_key"]; ?>)">
				<table><tr valign="top"><td>
				<?
				$sub = new Structure();
				$sub->key = $row["page_key"];
				$subpages = $sub->getStructure();
				if (sizeof($subpages) > 0)
				{
				?>	
				<div class="folder_arrow" onclick="loadTree(<?= $row["page_key"]; ?>)" id="arrow_<?= $row["page_key"]; ?>"><img src="system/img/collapsed.png" id="plus_<?= $row["page_key"]; ?>"></div>
				<?
				}
				else
				{
				?>
				<div class="folder_arrow" id="arrow_<?= $row["page_key"]; ?>"><img src="system/img/blank.gif" width="16" height="16" id="plus_<?= $row["page_key"]; ?>"></div>
				<?	
				}
				?>
				</td>
				<? if ($img == "oes_trash.png") { ?>
				<td onclick="loadMenu(<?= $row["page_key"]; ?>);" class="folder_td" title="<?= $this->adminLang["admin"][19]; ?>"><img src="system/img/<?= $img; ?>"></td>
				<div class="folder_image_menu" id="folder_image_menu_<?= $row["page_key"]; ?>" style="display:none;">
				<a href="Javascript:hideMenu();" class="context_title"><?= $this->adminLang["filepool"][43]; ?></a>
				<a href="Javascript:restorePage();" style="background-image:url(system/img/oes_restore.png);"><?= $this->adminLang["structure"][22]; ?></a>
				<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_delpage"] == 1))) { ?>
				<a href="Javascript:deletePage();" style="background-image:url(system/img/oes_pagedelete.png);"><?= $this->adminLang["structure"][23]; ?></a>
				<? } ?>
				<a href="Javascript:cutFolder();" style="background-image:url(system/img/oes_cut.png);"><?= $this->adminLang["structure"][1]; ?></a>
				</div>
				<? } elseif (($img == "oes_flag_green.png") || ($img == "oes_flag_yellow.png") || ($img == "oes_flag_red.png")) { ?>
				<td onclick="loadMenu(<?= $row["page_key"]; ?>);" class="folder_td" title="<?= $this->adminLang["admin"][19]; ?>"><img src="system/img/<?= $img; ?>"></td>
				<div class="folder_image_menu" id="folder_image_menu_<?= $row["page_key"]; ?>" style="display:none;">
				<a href="Javascript:hideMenu();" class="context_title"><?= $this->adminLang["filepool"][43]; ?></a>
				<a href="Javascript:cutFolder();" style="background-image:url(system/img/oes_cut.png);"><?= $this->adminLang["structure"][1]; ?></a>
				<a href="Javascript:copyFolder();" style="background-image:url(system/img/oes_copy.png);"><?= $this->adminLang["structure"][3]; ?></a>
				<? if ($_SESSION["account_group"] == 2) { ?>
				<a href="Javascript:deletePage();" style="background-image:url(system/img/oes_pagedelete.png);"><?= $this->adminLang["structure"][23]; ?></a>
				<a href="Javascript:forceExport();" style="background-image:url(system/img/oes_export.png);"><?= $this->adminLang["structure"][21]; ?></a>
				<? if ($this->set->getPagePermission() == 1) { ?>
				<a href="Javascript:editPermission();" style="background-image:url(system/img/oes_permission_add.png);"><?= $this->adminLang["structure"][15]; ?></a>
				<a href="Javascript:editforPermission();" style="background-image:url(system/img/oes_permission_delete.png);"><?= $this->adminLang["structure"][17]; ?></a>
				<? } ?>
				<a href="Javascript:editRSS();" style="background-image:url(system/img/oes_rss.png);"><?= $this->adminLang["rss"][1]; ?></a>
				<? } ?>
				<? if (($this->set->getSiteStaging() == 1) && (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))) { ?>
				<a href="Javascript:releaseContent();" style="background-image:url(system/img/oes_release.png);"><?= $this->adminLang["structure"][46]; ?></a>
				<? } ?>
				<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_treelink"] == 1))) { ?>
				<a href="Javascript:treeLink();" style="background-image:url(system/img/oes_treelink.png);"><?= $this->adminLang["structure"][41]; ?></a>
				<? } ?>
				<? if ($_SESSION["account_group"] == 2) { ?>
				<a href="Javascript:openToolbox();" style="background-image:url(system/img/oes_dump.png);">Toolbox/Information</a>
				<? } ?>
				</div>
				<? } else { ?>
				<td class="folder_td"><img src="system/img/<?= $img; ?>"></td>
				<div id="folder_image_menu_<?= $row["page_key"]; ?>"></div>
				<? } ?>
				<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_treelink"] == 1))) { ?>
				<? if ($row["treelink_key"] != 0) { ?>
				<td id="treelink_<?= $row["page_key"]; ?>"><a href="Javascript:treeLink();"><img src="system/img/oes_treelink.png"></a></td>
				<? } else { ?>
				<td id="treelink_<?= $row["page_key"]; ?>" style="display:none;"><a href="Javascript:treeLink();"><img src="system/img/oes_treelink.png"></a></td>
				<? } ?>
				<? } else { ?>
				<? if ($row["treelink_key"] != 0) { ?>
				<td id="treelink_<?= $row["page_key"]; ?>"><img src="system/img/oes_treelink.png"></td>
				<? } else { ?>
				<td id="treelink_<?= $row["page_key"]; ?>" style="display:none;"><img src="system/img/oes_treelink.png"></td>
				<? } ?>
				<? } ?>
				<? if ($perm_img != "") { ?>
				<? if ($perm_img == '<img src="system/img/oes_permission_add.png">') { ?>
				<td><a href="Javascript:editPermission();"><?= $perm_img; ?></a></td>
				<? } else { ?>
				<td><a href="Javascript:editforPermission();"><?= $perm_img; ?></a></td>
				<? } ?>
				<? } ?>
				<? if ($rss_img != "") { ?>
				<td><a href="Javascript:editRSS();"><?= $rss_img; ?></a></td>
				<? } ?>
				<? if (($row["page_forceexport"] == 1) && ($row["page_lockexport"] == 0) && ($_SESSION["account_group"] == 2)) { ?>
				<td><a href="Javascript:forceExport();"><img src="system/img/oes_export.png"></a></td>
				<? } elseif (($row["page_lockexport"] == 1) && ($_SESSION["account_group"] == 2)) { ?>
				<td><a href="Javascript:forceExport();"><img src="system/img/oes_exportlock.png"></a></td>
				<? } ?>
				<td><div class="folder_text" id="text_<?= $row["page_key"]; ?>"><a href="#" id="name_<?= $row["page_key"]; ?>"><? if ($site_encoding == "utf-8") { echo $row[$structure_block]; } else { echo utf8_decode($row[$structure_block]); } ?></a><? if ($row["page_extern"] != "") { ?><a href="<?= $row["page_extern"]; ?>" target="_blank">[<?= substr($row["page_extern"],0,40); ?><? if (strlen($row["page_extern"]) >= 40) { echo "..."; } ?>]</a><? } ?></div></td></tr></table>
				</div><div class="folder_subtree" id="folder_subtree_<?= $row["page_key"]; ?>"></div></div>
				<input type="hidden" id="startsite_<?= $row["page_key"]; ?>" value="0">
				<input type="hidden" id="path_<?= $row["page_key"]; ?>" value="<?= $row["page_path"]; ?>">
				<input type="hidden" id="perm_<?= $row["page_key"]; ?>" value="<?= $perm; ?>">
				<? 	
				}	
			}
		} 		
	}
	
	public function subFolders()
	{
		header("Content-type: text/xml");
		$key = $_POST["key"];
		$this->subArr = array();
		$this->subFolderKey($key);
?>
<?= "<"; ?>?xml version="1.0" ?<?= ">"; ?>
<root>
<?
foreach ($this->subArr as $value)
{
?>
	<folder>
		<key><?= $value; ?></key>
	</folder>
<?
}
?>	
</root>
<?		
	}
	
	public function forceExport()
	{
		$key = $_POST["key"];
		$mode = $_POST["mode"];
		$param = array("page_key" => $key);
		$query = "SELECT page_parent FROM ".$this->prefix."page WHERE page_key = :page_key";
		$forceArr = $this->db->row($query,$param);
		$page_parent = $forceArr["page_parent"];
		if ($mode == "0")
		{
			$le = 0;
			$fe = 0;
		}
		elseif ($mode == "1")
		{
			$le = 1;
			$fe = 0;
		}
		else
		{
			$le = 0;
			$fe = 1;
		}
		$param = array("page_forceexport" => $fe,"page_lockexport" => $le, "page_key" => $key);
		$query = "UPDATE ".$this->prefix."page SET page_forceexport = :page_forceexport, page_lockexport = :page_lockexport WHERE page_key = :page_key";
		$this->db->update($query,$param);
		echo $page_parent;		
	}
	
	public function restorePage()
	{
		$key = $_POST["key"];
		$param = array("page_key" => $key);
		$query = "SELECT page_parent FROM ".$this->prefix."page WHERE page_key = :page_key";
		$restoreArr = $this->db->row($query,$param);
		$page_parent = $restoreArr["page_parent"];
		$this->restoreAjaxPages($key);
		echo $page_parent;
	}
	
	public function restoreAjaxPages($k)
	{
		$param = array("page_key" => $k);
		$query = "UPDATE ".$this->prefix."page SET page_status = 2 WHERE page_key = :page_key";
		$this->db->update($query,$param);
		$param = array("page_parent" => $k);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent";
		$resArr = $this->db->select($query,$param);
		foreach ($resArr as $value)
		{
			$this->restoreAjaxPages($value["page_key"]);
		}
	}
	
	public function releaseContent()
	{
		$key = $_POST["key"];
		$param = array("page_key" => $key);
		$query = "SELECT page_parent FROM ".$this->prefix."page WHERE page_key = :page_key";
		$releaseArr = $this->db->row($query,$param);
		$page_parent = $releaseArr["page_parent"];
		$this->releaseAjaxContents($key);
		echo $page_parent;
	}
	
	public function releaseAjaxContents($k)
	{
		$param = array("page_key" => $k);
		$query = "SELECT * FROM ".$this->prefix."stage WHERE page_key = :page_key";
		$resArr = $this->db->select($query,$param);
		foreach ($resArr as $value)
		{
			$param = array("stage_input" => $value["stage_input"],"page_key" => $k);
			$query = "UPDATE ".$this->prefix."page SET ".$value["stage_edit"]." = :stage_input WHERE page_key = :page_key";
			$this->db->update($query,$param);
			$param = array("stage_key" => $value["stage_key"]);
			$query = "DELETE FROM ".$this->prefix."stage WHERE stage_key = :stage_key";
			$this->db->delete($query,$param);
		}
		$param = array("page_parent" => $k);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent";
		$resArr = $this->db->select($query,$param);
		foreach ($resArr as $value)
		{
			if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($this->user->pagePermission($value["page_key"]))))
			{
				$this->releaseAjaxContents($value["page_key"]);
			}
		}		
	}
	
	public function getPage()
	{
		$pageArr = $this->page->getPageKey($_POST["key"],true,true);
		echo $pageArr["page_path"];
	}
	
	public function getPath()
	{
		global $path;
		$str = "0,";
		foreach ($path as $value) 
		{ 
			$str .= $value["page_key"].",";
		}
		$str = substr($str,0,strlen($str) - 1);
		echo $str;
	}

	public function writePath($p,$c)
	{
		$structure_block = $this->set->getStructureBlock();
		if ($c <= sizeof($p))
		{
			$k = $p[$c];
			
			$param = array("page_parent" => $k);
			$query = "SELECT page_key,page_path,page_status,page_main,treelink_key,page_forceexport,page_lockexport,page_title,page_headline,page_navigation,page_extern FROM ".$this->prefix."page WHERE page_parent = :page_parent ORDER BY page_order desc";
			$resArr = $this->db->select($query,$param);
			foreach ($resArr as $row) 
			{
				if ($row["page_status"] == 0)
				{
					$img = "oes_flag_green.png";
				}
				else if ($row["page_status"] == 1)
				{
					$img = "oes_flag_yellow.png";
				}
				else if ($row["page_status"] == 2)
				{
					$img = "oes_flag_red.png";
				}
				else
				{
					$img = "oes_trash.png";
				}
				$perm = 1;
				if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 3))
				{
					if (!$this->user->pagePermission($row["page_key"]))
					{
						$img = 'oes_lock.png';						
						$perm = 0;
					}
				}
				$perm_img = '';
				if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 2))
				{
					$param = array("page_key" => $row["page_key"]);
					$query = "SELECT perm_key,perm_type FROM ".$this->prefix."permission WHERE page_key = :page_key";
					$permArr = $this->db->row($query,$param);
					if (sizeof($permArr) > 1)
					{
						if ($permArr["perm_type"] == 0)
						{
							$perm_img = '<img src="system/img/oes_permission_add.png">';
						}
						if ($permArr["perm_type"] == 1)
						{
							$perm_img = '<img src="system/img/oes_permission_delete.png">';
						}
					}
				}
				$rss_img = '';
				if ($_SESSION["account_group"] == 2)
				{
					$param = array("page_key" => $row["page_key"]);
					$query = "SELECT * FROM ".$this->prefix."rss WHERE page_key = :page_key";
					$rssArr = $this->db->row($query,$param);
					if (sizeof($rssArr) > 1)
					{
						$rss_img = '<img src="system/img/oes_rss.png">';
					}
				}
				if (($img != 'oes_lock.png') || ($row["page_status"] != 3))
				{
	?>
	<div class="folder_cont" id="folder_cont_<?= $row["page_key"]; ?>">
	<div class="folder_name" id="folder_name_<?= $row["page_key"]; ?>" onmouseover="borderOn(<?= $row["page_key"]; ?>)" onmouseout="borderOff(<?= $row["page_key"]; ?>)" ondblclick="loadTree(<?= $row["page_key"]; ?>)" onclick="activeFolder(<?= $row["page_key"]; ?>)">
	<table><tr valign="top"><td>
	<?
	$sub = new Structure();
	$sub->key = $row["page_key"];
	$subpages = $sub->getStructure();
	if (sizeof($subpages) > 0)
	{
	?>	
	<div class="folder_arrow" onclick="loadTree(<?= $row["page_key"]; ?>)" id="arrow_<?= $row["page_key"]; ?>"><img src="system/img/collapsed.png" id="plus_<?= $row["page_key"]; ?>"></div>
	<?
	}
	else
	{
	?>
	<div class="folder_arrow" id="arrow_<?= $row["page_key"]; ?>"><img src="system/img/blank.gif" width="16" height="16" id="plus_<?= $row["page_key"]; ?>"></div>
	<?	
	}
	?>
	</td>
	<? if ($img == "oes_trash.png") { ?>
	<td onclick="loadMenu(<?= $row["page_key"]; ?>);" class="folder_td" title="<?= $this->adminLang["admin"][19]; ?>"><img src="system/img/<?= $img; ?>"></td>
	<div class="folder_image_menu" id="folder_image_menu_<?= $row["page_key"]; ?>" style="display:none;">
	<a href="Javascript:hideMenu();" class="context_title"><?= $this->adminLang["filepool"][43]; ?></a>
	<a href="Javascript:restorePage();" style="background-image:url(system/img/oes_restore.png);"><?= $this->adminLang["structure"][22]; ?></a>
	<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_delpage"] == 1))) { ?>
	<a href="Javascript:deletePage();" style="background-image:url(system/img/oes_pagedelete.png);"><?= $this->adminLang["structure"][23]; ?></a>
	<? } ?>
	<a href="Javascript:cutFolder();" style="background-image:url(system/img/oes_cut.png);"><?= $this->adminLang["structure"][1]; ?></a>
	</div>
	<? } elseif (($img == "oes_flag_green.png") || ($img == "oes_flag_yellow.png") || ($img == "oes_flag_red.png")) { ?>
	<td onclick="loadMenu(<?= $row["page_key"]; ?>);" class="folder_td" title="<?= $this->adminLang["admin"][19]; ?>"><img src="system/img/<?= $img; ?>"></td>
	<div class="folder_image_menu" id="folder_image_menu_<?= $row["page_key"]; ?>" style="display:none;">
	<a href="Javascript:hideMenu();" class="context_title"><?= $this->adminLang["filepool"][43]; ?></a>
	<a href="Javascript:cutFolder();" style="background-image:url(system/img/oes_cut.png);"><?= $this->adminLang["structure"][1]; ?></a>
	<a href="Javascript:copyFolder();" style="background-image:url(system/img/oes_copy.png);"><?= $this->adminLang["structure"][3]; ?></a>
	<? if ($_SESSION["account_group"] == 2) { ?>
	<a href="Javascript:deletePage();" style="background-image:url(system/img/oes_pagedelete.png);"><?= $this->adminLang["structure"][23]; ?></a>
	<a href="Javascript:forceExport();" style="background-image:url(system/img/oes_export.png);"><?= $this->adminLang["structure"][21]; ?></a>
	<? if ($this->set->getPagePermission() == 1) { ?>
	<a href="Javascript:editPermission();" style="background-image:url(system/img/oes_permission_add.png);"><?= $this->adminLang["structure"][15]; ?></a>
	<a href="Javascript:editforPermission();" style="background-image:url(system/img/oes_permission_delete.png);"><?= $this->adminLang["structure"][17]; ?></a>
	<? } ?>
	<? } ?>
	<? if (($this->set->getSiteStaging() == 1) && (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_releasepage"] == 1)))) { ?>
	<a href="Javascript:releaseContent();" style="background-image:url(system/img/oes_release.png);"><?= $this->adminLang["structure"][46]; ?></a>
	<? } ?>
	<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_treelink"] == 1))) { ?>
	<a href="Javascript:treeLink();" style="background-image:url(system/img/oes_treelink.png);"><?= $this->adminLang["structure"][41]; ?></a>
	<? } ?>
	<? if ($_SESSION["account_group"] == 2) { ?>
	<a href="Javascript:openToolbox();" style="background-image:url(system/img/oes_dump.png);">Toolbox/Information</a>
	<? } ?>
	</div>
	<? } else { ?>
	<td class="folder_td"><img src="system/img/<?= $img; ?>"></td>
	<div id="folder_image_menu_<?= $row["page_key"]; ?>"></div>
	<? } ?>
	<? if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3) && ($_SESSION["account_treelink"] == 1))) { ?>
	<? if ($row["treelink_key"] != 0) { ?>
	<td id="treelink_<?= $row["page_key"]; ?>"><a href="Javascript:treeLink();"><img src="system/img/oes_treelink.png"></a></td>
	<? } else { ?>
	<td id="treelink_<?= $row["page_key"]; ?>" style="display:none;"><a href="Javascript:treeLink();"><img src="system/img/oes_treelink.png"></a></td>
	<? } ?>
	<? } else { ?>
	<? if ($row["treelink_key"] != 0) { ?>
	<td id="treelink_<?= $row["page_key"]; ?>"><img src="system/img/oes_treelink.png"></td>
	<? } else { ?>
	<td id="treelink_<?= $row["page_key"]; ?>" style="display:none;"><img src="system/img/oes_treelink.png"></td>
	<? } ?>
	<? } ?>
	<? if ($perm_img != "") { ?>
	<? if ($perm_img == '<img src="system/img/oes_permission_add.png">') { ?>
	<td><a href="Javascript:editPermission();"><?= $perm_img; ?></a></td>
	<? } else { ?>
	<td><a href="Javascript:editforPermission();"><?= $perm_img; ?></a></td>
	<? } ?>
	<? } ?>
	<? if ($rss_img != "") { ?>
	<td><a href="Javascript:editRSS();"><?= $rss_img; ?></a></td>
	<? } ?>
	<? if (($row["page_forceexport"] == 1) && ($row["page_lockexport"] == 0) && ($_SESSION["account_group"] == 2)) { ?>
	<td><a href="Javascript:forceExport();"><img src="system/img/oes_export.png"></a></td>
	<? } elseif (($row["page_lockexport"] == 1) && ($_SESSION["account_group"] == 2)) { ?>
	<td><a href="Javascript:forceExport();"><img src="system/img/oes_exportlock.png"></a></td>
	<? } ?>
	<td><div class="folder_text" id="text_<?= $row["page_key"]; ?>"><a href="#" id="name_<?= $row["page_key"]; ?>"><?= $row[$structure_block]; ?></a><? if ($row["page_extern"] != "") { ?><a href="<?= $row["page_extern"]; ?>" target="_blank">[<?= substr($row["page_extern"],0,40); ?><? if (strlen($row["page_extern"]) >= 40) { echo "..."; } ?>]</a><? } ?></div></td></tr></table>
	</div><div class="folder_subtree" id="folder_subtree_<?= $row["page_key"]; ?>">
	<?
				if (isset($p[$c + 1]))
				{
					if ($row["page_key"] == $p[$c + 1])
					{
						$c = $c + 1;
						$this->writePath($p,$c);			
					}
				}
	?>
	</div></div>
	<input type="hidden" id="startsite_<?= $row["page_key"]; ?>" value="0">
	<input type="hidden" id="path_<?= $row["page_key"]; ?>" value="<?= $row["page_path"]; ?>">
	<input type="hidden" id="perm_<?= $row["page_key"]; ?>" value="<?= $perm; ?>">
	<? 		
				}
			}
		}
	}

	public function cutFolder()
	{
		$key = $_POST["key"];
		$parent = $_POST["parent"];
		$param = array("page_parent" => $parent);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent";
		$page_order = $this->db->count($query,$param) + 1;
		$param = array("page_order" => $page_order,"page_parent" => $parent,"page_key" => $key);
		$query = "UPDATE ".$this->prefix."page SET page_order = :page_order, page_parent = :page_parent WHERE page_key = :page_key";
		$this->db->update($query,$param);
		$oe_helper = new Helper();
		$startsite_key = $oe_helper->getStartsite($key);
		$startsiteArr = $this->page->getPageKey($startsite_key,true,true);
		$this->updateLanguage($key,$startsiteArr["page_lang"]);
		$oe_changedate = new Changedate();
		$oe_changedate->update($parent);
		echo $parent;
	}
	
	public function copyFolder()
	{
		$page_key = $_POST["key"];
		$page_keynew = $_POST["parent"];
		$copysub = $_POST["copysub"];
		$oe_helper = new Helper();
		$startsite_key = $oe_helper->getStartsite($page_keynew);
		$startsiteArr = $this->page->getPageKey($startsite_key);
		$page_lang = $startsiteArr["page_lang"];
		$this->startCopy($page_key,$page_keynew,$copysub,$page_lang);
		echo $page_keynew;
	}
	
	public function copyStartsite()
	{
		$page_key = $_POST["key"];
		$match = $_POST["match"];
		$pattern = $_POST["pattern"];
		$this->startCopystartsite($page_key,0,$match,$pattern);
		echo 0;		
	}
	
	public function deletePagecache()
	{
		$query = "TRUNCATE TABLE ".$this->prefix."stage";
		$this->db->delete($query);
	}
	
	public function deleteTrash()
	{
		$query = "DELETE FROM ".$this->prefix."page WHERE page_status = 3";
		$this->db->delete($query);		
	}
	
	public function getStartsite()
	{
		$page_key = $_POST["key"];
		$pArr = $this->page->getParentPages($page_key);
		$s = $this->page->getPageKey($pArr[0]);
		$result_langs = $this->page->getLangs();
		?>
		<input type="hidden" id="edit_start_key" value="<?= $pArr[0]; ?>">
		<p class="adminText"><b><?= $this->adminLang["structure"][7]; ?>:</b><br>[<?= $s["page_key"]; ?>] <?= $s["page_title"]; ?></p>		
		<p class="adminText"><b><?= $this->adminLang["structure"][11]; ?>*:</b><br>
		<select class="admininput" id="edit_start_main">
		<option value="0" <? if ($s["page_main"] == 0) { ?>selected<? } ?>><?= $this->adminLang["structure"][12]; ?></option>
		<option value="1" <? if ($s["page_main"] == 1) { ?>selected<? } ?>><?= $this->adminLang["structure"][13]; ?></option>
		</select>
		</p>
		<p class="adminText"><b><?= $this->adminLang["structure"][14]; ?></b><br>
		<input type="text" class="admininput" id="page_exportfolder" value="<?= $s["page_exportfolder"]; ?>">
		</p>
		<p class="adminText">
		<b><?= $this->adminLang["properties"][24]; ?></b><br>
		<select id="page_lang" name="page_lang" class="admininput">
		<option value=""><?= $this->adminLang["properties"][25]; ?></option>
		<? foreach ($result_langs as $row) { ?>
		<option value="<?= $row["lang_short"]; ?>"<? echo ($row["lang_short"] == $s["page_lang"] ? " selected" : "" ) ?>><?= $row["lang_short"]; ?> [<?= $row["lang_name"]; ?>]</option>
		<? } ?>
		</select>
		</p>
		<p class="adminText"><b><?= $this->adminLang["structure"][45]; ?></b><br>
		<input type="text" class="admininput" id="page_lang_alt" value="<?= $s["page_lang_alt"]; ?>">
		</p>
		<?				
	}
	
	public function getHtmlExport()
	{
		$s = $this->page->getPageKey($_POST["key"]);
		?>
		<p class="adminText">
		<b>Exporteinstellung</b><br>
		<select class="admininput" id="export_mode">
		<option value="0" <? if (($s["page_lockexport"] == 0) && ($s["page_forceexport"] == 0)) { ?>selected<? } ?>>Seite wird exportiert</option>
		<option value="1" <? if ($s["page_lockexport"] == 1) { ?>selected<? } ?>>Export der Seite sperren</option>
		<option value="2" <? if (($s["page_lockexport"] == 0) && ($s["page_forceexport"] == 1)) { ?>selected<? } ?>>Export der Seite erzwingen</option>
		</select>
		</p>
		<?
	}

	public function getRSS()
	{
		$param = array("page_key" => $_POST["key"]);
		$query = "SELECT * FROM ".$this->prefix."rss WHERE page_key = :page_key";
		$rssArr = $this->db->row($query,$param);
		if (sizeof($rssArr) == 1)
		{
		?>
		<form id="rssform" name="rssform" onsubmit="return false">
		<p class="adminText"><b><?= $this->adminLang["rss"][2]; ?>*:</b><br>
		<input type="text" class="admininput" id="rss_title" name="rss_title">
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][3]; ?>*:</b><br>
		<textarea id="rss_description" name="rss_description" class="admininputarea"></textarea>
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][4]; ?>*:</b><br>
		<select class="admininput" id="rss_size" name="rss_size">
		<option value="5">5</option>
		<option value="10" selected>10</option>
		<option value="20">20</option>
		<option value="50">50</option>
		</select>
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][5]; ?>*:</b><br>
		<select class="admininput" id="rss_order" name="rss_order">
		<option value="page_order" selected><?= $this->adminLang["rss"][6]; ?></option>
		<option value="page_date_unformated"><?= $this->adminLang["rss"][7]; ?></option>
		</select>
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][9]; ?>*:</b><br>
		<select class="admininput" id="rss_export" name="rss_export">
		<option value="0" selected><?= $this->adminLang["rss"][10]; ?></option>
		<option value="1"><?= $this->adminLang["rss"][11]; ?></option>
		</select>
		</p>
		</form>
		<?			
		}
		else
		{
		?>			
		<form id="rssform" name="rssform" onsubmit="return false">
		<p class="adminText"><b><?= $this->adminLang["rss"][2]; ?>*:</b><br>
		<input type="text" class="admininput" id="rss_title" name="rss_title" value="<?= $rssArr["rss_title"]; ?>">
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][3]; ?>*:</b><br>
		<textarea id="rss_description" name="rss_description" class="admininputarea"><?= $rssArr["rss_description"]; ?></textarea>
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][4]; ?>*:</b><br>
		<select class="admininput" id="rss_size" name="rss_size">
		<option value="5" <? if ($rssArr["rss_size"] == 5) { echo "selected"; } ?>>5</option>
		<option value="10" <? if ($rssArr["rss_size"] == 10) { echo "selected"; } ?>>10</option>
		<option value="20" <? if ($rssArr["rss_size"] == 20) { echo "selected"; } ?>>20</option>
		<option value="50" <? if ($rssArr["rss_size"] == 50) { echo "selected"; } ?>>50</option>
		</select>
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][5]; ?>*:</b><br>
		<select class="admininput" id="rss_order" name="rss_order">
		<option value="page_order" <? if ($rssArr["rss_order"] == "page_order") { echo "selected"; } ?>><?= $this->adminLang["rss"][6]; ?></option>
		<option value="page_date_unformated" <? if ($rssArr["rss_order"] == "page_date_unformated") { echo "selected"; } ?>><?= $this->adminLang["rss"][7]; ?></option>
		</select>
		</p>
		<p class="adminText"><b><?= $this->adminLang["rss"][9]; ?>*:</b><br>
		<select class="admininput" id="rss_export" name="rss_export">
		<option value="0" <? if ($rssArr["rss_export"] == 0) { echo "selected"; } ?>><?= $this->adminLang["rss"][10]; ?></option>
		<option value="1" <? if ($rssArr["rss_export"] == 1) { echo "selected"; } ?>><?= $this->adminLang["rss"][11]; ?></option>
		</select>
		</p>
		<p><input type="checkbox" id="del_rss" name="del_rss" value="1"><?= $this->adminLang["rss"][8]; ?></p>
		</form>
		<?			
		}		
	}
	
	public function saveRSS()
	{
		global $site_encoding;
		$page_key = $_POST["key"];
		$pageArr = $this->page->getPageKey($page_key);
		if ($site_encoding == "utf-8")
		{
			$rss_title = $_POST["rss_title"];
			$rss_description = $_POST["rss_description"];
		}
		else
		{
			$rss_title = utf8_decode($_POST["rss_title"]);
			$rss_description = utf8_decode($_POST["rss_description"]);
		}
		$rss_size = $_POST["rss_size"];
		$rss_order = $_POST["rss_order"];
		$rss_export = $_POST["rss_export"];
		if (isset($_POST["del_rss"]))
		{
			$param = array("page_key" => $page_key);
			$query = "DELETE FROM ".$this->prefix."rss WHERE page_key = :page_key";
			$this->db->delete($query,$param);
			echo $pageArr["page_parent"];	
		}
		else
		{
			$param = array("page_key" => $page_key);
			$query = "SELECT * FROM ".$this->prefix."rss WHERE page_key = :page_key";
			$resArr = $this->db->row($query,$param);
			if (sizeof($resArr) == 1)
			{
				$param = array("page_key" => $page_key,"rss_title" => $rss_title,"rss_description" => $rss_description,"rss_size" => $rss_size,"rss_order" => $rss_order,"rss_export" => $rss_export);
				$query = "INSERT INTO ".$this->prefix."rss (page_key,rss_title,rss_description,rss_size,rss_order,rss_export) VALUES (:page_key,:rss_title,:rss_description,:rss_size,:rss_order,:rss_export)";
				$this->db->insert($query,$param);
				echo $pageArr["page_parent"];	
			}
			else
			{
				$param = array("page_key" => $page_key,"rss_title" => $rss_title,"rss_description" => $rss_description,"rss_size" => $rss_size,"rss_order" => $rss_order,"rss_export" => $rss_export);
				$query = "UPDATE ".$this->prefix."rss SET rss_title = :rss_title,rss_description = :rss_description,rss_size = :rss_size,rss_order = :rss_order,rss_export = :rss_export WHERE page_key = :page_key";
				$this->db->update($query,$param);
				echo $pageArr["page_parent"];	
			}
		}		
	}
	
	public function editStartsite()
	{
		global $page;
		$page_key = $_POST["key"];
		$page_main = $_POST["startmain"];
		$page_exportfolder = $_POST["exportfolder"];
		$page_lang = $_POST["pagelang"];
		$page_lang_alt = $_POST["pagelangalt"];
		if ($page_main == 1)
		{
			$query = "UPDATE ".$this->prefix."page SET page_main = 0";
			$this->db->update($query);
			$param = array("page_key" => $page_key);
			$query = "UPDATE ".$this->prefix."page SET page_main = 1,page_status = 0 WHERE page_key = :page_key";
			$this->db->update($query,$param);
		}
		else
		{
			$pArr = $this->page->getPageKey($page_key);
			if ($pArr["page_main"] == 1)
			{
				$query = "UPDATE ".$this->prefix."page SET page_main = 0";
				$this->db->update($query);
				$query = "SELECT * FROM ".$this->prefix."page WHERE page_parent = 0";
				$mArr = $this->db->row($query);
				$param = array("page_key" => $mArr["page_key"]);
				$query = "UPDATE ".$this->prefix."page SET page_main = 1 WHERE page_key = :page_key";
				$this->db->update($query,$param);
			}
		}
		$param = array("page_exportfolder" => $page_exportfolder,"page_lang_alt" => $page_lang_alt,"page_key" => $page_key);
		$query = "UPDATE ".$this->prefix."page SET page_exportfolder = :page_exportfolder, page_lang_alt = :page_lang_alt WHERE page_key = :page_key";
		$this->db->update($query,$param);
		$this->updateLanguage($page_key,$page_lang);
		echo $page["page_path"];		
	}
	
	public function newStartsite()
	{
		global $page;
		$startname = $_POST["startname"];
		$page_pathnew = $_POST["startpath"];
		$page_template = "default";
		$page_create = date("YmdHis");
		$page_creator = $_SESSION["account_email"];
		$param = array("page_path" => $page_pathnew);
		$query = "SELECT * FROM ".$this->prefix."page WHERE page_path = :page_path";
		$resArr = $this->db->row($query,$param);
		if (sizeof($resArr) == 1)
		{
			$param = array("startname1" => $startname,"startname2" => $startname,"startname3" => $startname,"page_pathnew" => $page_pathnew,"page_template" => $page_template,"page_create" => $page_create,"page_creator" => $page_creator,"page_exportdate" => "0000-00-00 00:00:00");
			$query = "INSERT ".$this->prefix."page (page_parent,page_description,page_keywords,page_headline,page_title,page_navigation,page_path,page_status,page_order,page_template,page_att1,page_att2,page_date,page_date_unformated,page_lang,page_create,page_creator,page_change,page_main,page_exportdate) VALUES ('0','','',:startname1,:startname2,:startname3,:page_pathnew,'2','1',:page_template,'','','','','',:page_create,:page_creator,'','0',:page_exportdate)";
			$this->db->insert($query,$param);
			echo $page["page_path"];
		}
		else
		{
			echo "0";
		}		
	}
	
	public function getPermission()
	{
		$page_key = $_POST["key"];
		$query = "SELECT * FROM ".$this->prefix."account WHERE account_group = 3 and account_lock = 0 order by account_email";
		$resArr = $this->db->select($query);
		?>
		<p class="adminText"><?= $this->adminLang["structure"][39]; ?></p>
		<form name="formular" id="formular">
		<table border="0" cellpadding="0" cellspacing="0">
		<? 
		foreach($resArr as $row) 
		{ 
			$account_key = $row["account_key"];
			$param = array("account_key" => $account_key,"page_key" => $page_key);
			$query = "SELECT * FROM ".$this->prefix."permission WHERE account_key = :account_key and page_key = :page_key and perm_type = 0";
			$resArr2 = $this->db->row($query,$param);
			$selected = "";	
			if (sizeof($resArr2) > 1)
			{
				$selected = "checked";	
			}
			?>
		<tr valign="top">
		<td style="padding-right:5px;"><input name="account" value="<?= $account_key; ?>" <?= $selected; ?> type="checkbox" style="border-color: #fff;"></td>
		<td><p class="adminText" style="margin-top:0px;"><?= $row["account_email"]; ?></p></td>
		</tr>
		<? } ?>
		</table>
		</form>
		<?				
	}
	
	public function deletePage()
	{
		$key = $_POST["key"];
		$param = array("page_key" => $key);
		$query = "SELECT * FROM ".$this->prefix."page WHERE page_key = :page_key";
		$pA = $this->db->row($query,$param);
		$page_parent = $pA["page_parent"];
		$this->delAjaxPage($page_parent,$key);
		if ($page_parent == 0)
		{
			$query = "SELECT * FROM ".$this->prefix."page WHERE page_main = 1";
			$pA = $this->db->row($query);
			$page_path = $pA["page_path"];
			echo $page_path;
		}
		else
		{
			$param = array("page_key" => $page_parent);
			$query = "SELECT * FROM ".$this->prefix."page WHERE page_key = :page_key";
			$pA = $this->db->row($query,$param);
			$page_path = $pA["page_path"];
			echo $page_path;
		}		
	}
	
	public function getForPermission()
	{
		$page_key = $_POST["key"];
		$query = "SELECT * FROM ".$this->prefix."account WHERE account_group = 3 and account_lock = 0 order by account_email";
		$resArr = $this->db->select($query);
		?>
		<p class="adminText"><?= $this->adminLang["structure"][40]; ?></p>
		<form name="forformular" id="forformular">
		<table border="0" cellpadding="0" cellspacing="0">
		<? 
		foreach($resArr as $row) 
		{ 
			$account_key = $row["account_key"];
			$param = array("account_key" => $account_key,"page_key" => $page_key);
			$query = "SELECT * FROM ".$this->prefix."permission WHERE account_key = :account_key and page_key = :page_key and perm_type = 1";
			$resArr2 = $this->db->row($query,$param);
			$selected = "";	
			if (sizeof($resArr2) > 1)
			{
				$selected = "checked";	
			}
			?>
		<tr valign="top">
		<td style="padding-right:5px;"><input name="account" value="<?= $account_key; ?>" <?= $selected; ?> type="checkbox" style="border-color: #fff;"></td>
		<td><p class="adminText" style="margin-top:0px;"><?= $row["account_email"]; ?></p></td>
		</tr>
		<? } ?>
		</table>
		</form>
		<?				
	}
	
	public function getTreelinks()
	{
		$page_key = $_POST["key"];
		$pA = $this->page->getPageKey($page_key);
		if ($pA["treelink_key"] == 0)
		{
			echo "0";
		}
		else
		{
			$treeArr = array();
			$treelink_key = $pA["treelink_key"];
			$param = array("treelink_key" => $treelink_key);
			$query = "SELECT * FROM ".$this->prefix."page WHERE treelink_key = :treelink_key";
			$resArr = $this->db->select($query,$param);	
			foreach ($resArr as $row)
			{
				array_push($treeArr,$row["page_key"]);
			}
			echo implode(",",$treeArr);			
		}		
	}
	
	public function getTreecontent()
	{
		$list = $_POST["list"];
		if ($list != "")
		{
			$listArr = explode(",",$list);
		?>
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr valign="top">
		<td width="100%" height="20"><b><?= $this->adminLang["structure"][43]; ?></b></td>
		<td><b><?= $this->adminLang["structure"][44]; ?></b></td>
		<td></td>
		</tr>
		<?		
			foreach($listArr as $value)
			{
				$pA = $this->page->getPageKey($value);
				$hArr = $this->page->getParentPages($pA["page_key"]);
				$lArr = $this->page->getPageKey($hArr[0]);
		?>
		<tr valign="top">
		<td style="padding-right:5px;"><?= $pA["page_title"] ?> [<?= $pA["page_key"] ?>]</td>
		<td style="padding-right:5px;"><?= $this->page->getLangName($lArr["page_lang"]); ?></td>
		<td><a href="Javascript:deleteTreelink(<?= $value; ?>)"><img src="system/img/oes_link_delete.png" style="margin-left:3px;"></a></td>
		</tr>
		<?			
			}
		?>
		<table>
		<?		
		}		
	}
	
	public function checkTreelinks()
	{
		$page_key = $_POST["key"];
		$tp = $this->page->getPageKey($page_key);
		if ($tp["treelink_key"] == 0)
		{
			echo "0";
		}
		else
		{
			echo "1";
		}		
	}
	
	public function saveTreelink()
	{
		$oe_changedate = new Changedate();
		$list = $_POST["list"];
		$key = $_POST["key"];
		if ($list != "")
		{
			$listArr = explode(",",$list);
			$newlink = true;
			foreach ($listArr as $value)
			{
				$param = array("page_key" => $value);
				$query = "SELECT treelink_key FROM ".$this->prefix."page WHERE page_key = :page_key";
				$pA = $this->db->row($query,$param);
				if ($newlink)
				{
					if ($pA["treelink_key"] != 0)
					{
						$treelink_key = $pA["treelink_key"];
						$newlink = false;
					}
				}
			}
			if ($newlink)
			{
				$query = "INSERT INTO ".$this->prefix."treelink (treelink_type) VALUES ('1')";
				$treelink_key = $this->db->insert($query);
			}
			
			$param = array("treelink_key" => $treelink_key);
			$param = array("treelink_key" => $treelink_key);
			$query = "UPDATE ".$this->prefix."page SET treelink_key = 0 WHERE treelink_key = :treelink_key";
			$this->db->update($query,$param);
			$listArr = explode(",",$list);
			foreach ($listArr as $value)
			{
				$param = array("treelink_key" => $treelink_key,"page_key" => $value);
				$query = "UPDATE ".$this->prefix."page SET treelink_key = :treelink_key WHERE page_key = :page_key";
				$this->db->update($query,$param);
				$oe_changedate->update($value);
			}
		}
		else
		{
			$pA = $this->page->getPageKey($key);
			$treelink_key = $pA["treelink_key"];
			$param = array("treelink_key" => $treelink_key);
			$query = "SELECT page_key FROM ".$this->prefix."page WHERE treelink_key = :treelink_key";
			$resArr = $this->db->select($query,$param);
			foreach ($resArr as $value)
			{
				$oe_changedate->update($value["page_key"]);	
			}
			$param = array("treelink_key" => $treelink_key);
			$query = "UPDATE ".$this->prefix."page SET treelink_key = 0 WHERE treelink_key = :treelink_key";
			$this->db->update($query,$param);
			$param = array("treelink_key" => $treelink_key);
			$query = "DELETE FROM ".$this->prefix."treelink WHERE treelink_key = :treelink_key";
			$this->db->delete($query,$param);
		}		
	}
	
	public function savePermission()
	{
		$page_key = $_POST["key"];
		$accounts = $_POST["accounts"];
		$param = array("page_key" => $page_key);
		$query = "DELETE FROM ".$this->prefix."permission where page_key = :page_key";
		$this->db->delete($query,$param);
		if ($accounts != "")
		{
			$accounts = substr($accounts,0,strlen($accounts) - 1);
			$accountsArr = explode(",",$accounts);
			foreach ($accountsArr as $value)
			{
				$param = array("page_key" => $page_key,"account_key" => $value);
				$query = "INSERT INTO ".$this->prefix."permission (page_key,account_key,perm_type) VALUES (:page_key,:account_key,'0')";
				$this->db->insert($query,$param);
			}				
		}
		$page_parent = $this->page->getPageKey($page_key);
		echo $page_parent["page_parent"];		
	}
	
	public function saveForPermission()
	{
		$page_key = $_POST["key"];
		$accounts = $_POST["accounts"];
		$param = array("page_key" => $page_key);
		$query = "DELETE FROM ".$this->prefix."permission where page_key = :page_key";
		$this->db->delete($query,$param);
		if ($accounts != "")
		{
			$accounts = substr($accounts,0,strlen($accounts) - 1);
			$accountsArr = explode(",",$accounts);
			foreach ($accountsArr as $value)
			{
				$param = array("page_key" => $page_key,"account_key" => $value);
				$query = "INSERT INTO ".$this->prefix."permission (page_key,account_key,perm_type) VALUES (:page_key,:account_key,'1')";
				$this->db->insert($query,$param);
			}				
		}
		$page_parent = $this->page->getPageKey($page_key);
		echo $page_parent["page_parent"];		
	}
	
	public function searchPage()
	{
		global $site_encoding;
		$searchitem = $_POST["searchitem"];
		if ($site_encoding != "utf-8") 
		{ 
			$searchitem2 = $searchitem;
		}
		else
		{
			$searchitem2 = htmlentities(utf8_decode($searchitem));
		}
		$selector = $_POST["searchselector"];
		$filter = $_POST["searchfilter"];
		$fieldname = $_POST["searchfieldname"];
		?>
		<div style="padding:5px;">
		<?		
		if (strlen($searchitem) > 3)
		{
			$query = "SELECT * FROM ".$this->prefix."page WHERE (" 
			."page_keywords like '%$searchitem%' or "
			."page_description like '%$searchitem%' or "
			."page_path like '%$searchitem%' or "
			."page_title like '%$searchitem%' or "
			."page_headline like '%$searchitem%' or "
			."page_navigation like '%$searchitem%' or "
			."page_title like '%$searchitem2%' or "
			."page_headline like '%$searchitem2%' or "
			."page_navigation like '%$searchitem2%') AND page_status <> 3 ORDER BY page_title";
			$resArr = $this->db->select($query);	
			if (sizeof($resArr) > 1)
			{
				foreach ($resArr as $row)
				{
					if ($row["page_status"] == 0)
					{
						$img = "oes_flag_green.png";
					}
					else if ($row["page_status"] == 1)
					{
						$img = "oes_flag_yellow.png";
					}
					else if ($row["page_status"] == 2)
					{
						$img = "oes_flag_red.png";
					}
					else
					{
						$img = "oes_trash.png";
					}
					if (($this->set->getPagePermission() == 1) && ($_SESSION["account_group"] == 3))
					{
						if ($this->user->pagePermission($row["page_key"]))
						{
							$img = 'oes_lock.png';
						}
					}
					$loadpath = "website.php?id=".$row["page_path"]."&admin=structure";
					if ($selector != "")
					{
						$loadpath .= "&selector=".$selector;
					}
					if ($filter != "")
					{
						$loadpath .= "&filter=".$filter;
					}
					if ($fieldname != "")
					{
						$loadpath .= "&field_name=".$fieldname;
					}
				?>
				<div class="searchitem" style="border:1px solid #fff;position:relative;cursor:pointer;" id="searchitem_<?= $row["page_key"]; ?>" onmouseover="searchborderOn(<?= $row["page_key"]; ?>)" onmouseout="searchborderOff(<?= $row["page_key"]; ?>)">
				<input type="hidden" id="infostatus_<?= $row["page_key"]; ?>" value="0">
				<table>
				<tr valign="top">
				<td><div onclick="showSearchInfo(<?= $row["page_key"]; ?>)"><img src="system/img/collapsed.png" id="searcharrow_<?= $row["page_key"] ?>"></div></td>
				<td><img src="system/img/<?= $img; ?>"></td>
				<td><div onclick="loadPage('<?= $loadpath; ?>')"><?= $row["page_title"]; ?> [<?= $row["page_key"]; ?>]</div></td>
				</tr>
				</table>
				<div id="info_<?= $row["page_key"]; ?>" style="display:none;padding-left:22px;">
				<p class="adminText"><b><?= $this->adminLang["properties"][5]; ?>:</b><br><?= $row["page_path"]; ?><br>
				<b><?= $this->adminLang["properties"][2]; ?>:</b><br><?= $row["page_headline"]; ?><br>
				<b><?= $this->adminLang["properties"][4]; ?>:</b><br><?= $row["page_navigation"]; ?><br>
				<b>Template:</b><br><?= $row["page_template"]; ?></p>
				</div>
				</div>
				<?			
				}
			}
			else
			{
				?>
				<p class="adminText"><?= $this->adminLang["structure"][37]; ?></p>
				<?
			}
		}
		else
		{
		?>
		<p class="adminText"><?= $this->adminLang["structure"][38]; ?></p>
		<?			
		}
		?>
		</div>
		<?				
	}
	
	public function subFolderKey($key)
	{
		array_push($this->subArr, $key);
		$param = array("page_parent" => $key);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent";
		$resArr = $this->db->select($query,$param);
		
		foreach ($resArr as $row)
		{
			$this->subFolderKey($row["page_key"]);
		}	
	}
	
	public function delAjaxPage($page_parent,$page_key)
	{
		$param = array("page_parent" => $page_parent,"page_key" => $page_key);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent AND page_key <> :page_key ORDER BY page_order";
		$resArr = $this->db->select($query,$param);
		$counter = 1;
		foreach ($resArr as $row)
		{
			$param = array("page_order" => $counter, "page_key" => $row["page_key"]);
			$query = "UPDATE ".$this->prefix."page SET page_order = :page_order WHERE page_key = :page_key";
			$this->db->update($query,$param);
			$counter++;
		}
		$this->delAjaxPages($page_key);
	}
	
	public function delAjaxPages($page_key)
	{
		$param = array("page_key" => $page_key);
		$query = "SELECT treelink_key FROM ".$this->prefix."page WHERE page_key = :page_key";
		$pA = $this->db->row($query,$param);
		if ($pA["treelink_key"] != 0)
		{
			$treelink_key = $pA["treelink_key"];
			$param = array("treelink_key" => $treelink_key);
			$query = "SELECT * FROM ".$this->prefix."page WHERE treelink_key = :treelink_key";
			$resArr = $this->db->row($query,$param);
			if (sizeof($resArr) > 1)
			{
				$param = array("treelink_key" => $treelink_key);
				$query = "DELETE FROM ".$this->prefix."treelink WHERE treelink_key = :treelink_key";
				$this->db->delete($query,$param);
			}
		}
		$param = array("page_key" => $page_key);
		$query = "DELETE FROM ".$this->prefix."page WHERE page_key = :page_key";
		$this->db->delete($query,$param);
		$param = array("page_key" => $page_key);
		$query = "DELETE FROM ".$this->prefix."permission WHERE page_key = :page_key";
		$this->db->delete($query,$param);
		$param = array("page_key" => $page_key);
		$query = "DELETE FROM ".$this->prefix."stage WHERE page_key = :page_key";
		$this->db->delete($query,$param);
		$param = array("page_parent" => $page_key);
		$query = "SELECT page_key FROM ".$this->prefix."page WHERE page_parent = :page_parent";
		$resArr = $this->db->select($query,$param);
		foreach ($resArr as $row)
		{
			$this->delAjaxPages($row["page_key"]);
		}
	}
	
	public function updateLanguage($page_key,$page_lang)
	{
		$oe_changedate = new Changedate();
		$oe_changedate->update($page_key);
		$param = array("page_lang" => $page_lang,"page_key" => $page_key);
		$query = "UPDATE ".$this->prefix."page SET page_lang = :page_lang WHERE page_key = :page_key";
		$this->db->update($query,$param);
		$param = array("page_key" => $page_key);
		$query = "SELECT page_key,page_parent FROM ".$this->prefix."page WHERE page_parent = :page_key";
		$resArr = $this->db->select($query,$param);
		foreach ($resArr as $row)
		{
			$this->updateLanguage($row["page_key"],$page_lang);
		}
	}
		
	public function startCopy($key,$parent,$copysub,$page_lang)
	{
		$pagekey = $this->page->getPageKey($key);
		$page_path_old = $pagekey["page_path"];
		
		$query = "SELECT * FROM ".$this->prefix."page WHERE page_key = $key";
		$result = mysql_query($query);
		if (mysql_num_rows($result) == 1)
		{
			$menge = mysql_num_fields($result);
			$row = mysql_fetch_row ($result);
			for($x = 0; $x < $menge; $x++)
			{
				$page[mysql_field_name($result,$x)] = $row[$x];
			}
			$fields = "INSERT INTO ".$this->prefix."page (";
			while(list($arrkey, $arrval) = each ($page))
			{
				if ($arrkey != "page_key")
				{
					$fields .= $arrkey.",";
				}
			}
			$fields = substr($fields,0,strlen($fields)-1);
			$fields .= ") VALUES (";
			reset($page);
			while(list($arrkey, $arrval) = each ($page))
			{
				if ($arrkey != "page_key")
				{
					if ($arrkey == "page_parent")
					{
						$fields .= "'".$parent."',";
					}
					elseif ($arrkey == "page_order")
					{
						$query = "SELECT page_key FROM ".$this->prefix."page WHERE (page_parent = $parent)";
						$result = mysql_query($query);
						$page_order = mysql_num_rows($result) + 1;
						$fields .= "'".$page_order."',";
					}
					elseif ($arrkey == "page_count")
					{
						$fields .= "'0',";
					}
					elseif ($arrkey == "page_status")
					{
						$fields .= "'2',";
					}
					else
					{
						$fields .= "'".addslashes($arrval)."',";
					}
				}
			}
			$fields = substr($fields,0,strlen($fields)-1);
			$fields .= ")";
			$result = mysql_query($fields);
			$parent = mysql_insert_id();
			
			$param = array("page_key" => $parent,"page_lang" => $page_lang);
			$query = "UPDATE ".$this->prefix."page SET page_lang = :page_lang, treelink_key = 0 WHERE page_key = :page_key";
			$result = $this->db->update($query,$param);

			$file_name = $this->getFilename($page_path_old);
			$file_name_new = $parent."_".$file_name;
			$page_path_new = str_replace($file_name,$file_name_new,$page_path_old);
			
			$param = array("page_path" => $page_path_new,"page_key" => $parent);
			$query = "UPDATE ".$this->prefix."page SET page_path = :page_path WHERE page_key = :page_key";
			$result = $this->db->update($query,$param);
			
			if ($copysub == 1)
			{
				$param = array("page_parent" => $key);
				$query = "SELECT * FROM ".$this->prefix."page WHERE page_parent = :page_parent ORDER BY page_order";
				$resultArr = $this->db->select($query,$param);
				foreach ($resultArr as $row)
				{
					$this->startCopy($row["page_key"],$parent,$copysub,$page_lang);
				}
			}
		}
	}
		
	public function startCopystartsite($key,$parent,$match,$pattern)
	{
		$pagekey = $this->page->getPageKey($key);
		$page_path_old = $pagekey["page_path"];
		
		$query = "SELECT * FROM ".$this->prefix."page WHERE page_key = $key";
		$result = mysql_query($query);
		if (mysql_num_rows($result) == 1)
		{
			$menge = mysql_num_fields($result);
			$row = mysql_fetch_row ($result);
			for($x = 0; $x < $menge; $x++)
			{
				$page[mysql_field_name($result,$x)] = $row[$x];
			}
			$fields = "INSERT INTO ".$this->prefix."page (";
			while(list($arrkey, $arrval) = each ($page))
			{
				if ($arrkey != "page_key")
				{
					$fields .= $arrkey.",";
				}
			}
			$fields = substr($fields,0,strlen($fields)-1);
			$fields .= ") VALUES (";
			reset($page);
			while(list($arrkey, $arrval) = each ($page))
			{
				if ($arrkey != "page_key")
				{
					if ($arrkey == "page_parent")
					{
						$fields .= "'".$parent."',";
					}
					elseif ($arrkey == "page_order")
					{
						$query = "SELECT page_key FROM ".$this->prefix."page WHERE (page_parent = $parent)";
						$result = mysql_query($query);
						$page_order = mysql_num_rows($result) + 1;
						$fields .= "'".$page_order."',";
					}
					elseif ($arrkey == "page_count")
					{
						$fields .= "'0',";
					}
					elseif ($arrkey == "page_main")
					{
						$fields .= "'0',";
					}
					else
					{
						$fields .= "'".addslashes($arrval)."',";
					}
				}
			}
			$fields = substr($fields,0,strlen($fields)-1);
			$fields .= ")";
			$result = mysql_query($fields);
			$parent = mysql_insert_id();
			
			$file_name = $this->getFilename($page_path_old);
			$file_name_new = $parent."_".$file_name;
			$page_path_new = str_replace($file_name,$file_name_new,$page_path_old);
						
			if (($match != "") && ($pattern != ""))
			{
				if (strlen($page_path_old) > strlen($match) + 4)
				{
					$page_path_temp2 = substr($page_path_old,0,strlen($match));
					if ($page_path_temp2 == $match)
					{
						$page_path_temp = substr($page_path_old,strlen($match),strlen($page_path_old));
						$page_path_temp = $pattern.$page_path_temp;
						$query = "SELECT page_path FROM ".$this->prefix."page WHERE page_path = '$page_path_temp'";
						$replace = mysql_query($query);
						if (mysql_num_rows($replace) == 0)
						{
							$page_path_new = $page_path_temp;
						}
					}
				}
			}
			$query = "UPDATE ".$this->prefix."page SET page_path = '$page_path_new' where page_key = $parent";
			$result = mysql_query($query);
			$query = "SELECT * FROM ".$this->prefix."page WHERE page_parent = $key order by page_order";
			$result = mysql_query($query);
			while ($row = mysql_fetch_array($result))
			{
				$this->startCopystartsite($row["page_key"],$parent,$match,$pattern);
			}
		}
	}

	/**
	 * Ermittelt den Dateinamen aufgrund eines Pfades.
	 *
	 * @param string $page_path Seitenpfad mit Dateinamen
	 * @return string Dateiname
	 */
	public function getFilename($page_path)
	{
		$matchArr = explode("/",$page_path);
		$page_file = $matchArr[sizeof($matchArr) - 1];
		return $page_file;		
	}	
}
?>