<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class Structure
{
	private $db;
	private $prefix;
	public $template;
	public $key;
	public $order;
	public $checkhide;
	public $checkexternal;
	public $setwebsite;
	public $resultset;
	public $start;
	public $stepsize;
	private $set;
	private $page;
	public $navigation;
	private $export_folder;
	private $site_url;
	
	public function Structure()
	{
		global $oe_db,$db_praefix,$oe_set,$oe_page,$path,$site_url,$page;
		$this->db = $oe_db;
		$this->prefix = $db_praefix;
		$this->set = $oe_set;
		$this->template = "";
		$this->key = 0;
		$this->order = "";
		$this->checkhide = false;
		$this->checkexternal = false;
		$this->setwebsite = false;	
		$this->resultset = false;
		$this->start = 0;
		$this->stepsize = 0;
		$this->navigation = false;
		$this->page = $oe_page;
		$this->export_folder = $path[0]["page_exportfolder"];
		$this->site_url = $site_url;
		$this->current = $page;
	}

	public function getStructure()
	{
		$account_status = 0;
		$access = "";
		if (empty($_GET["export"]))
		{
			$account_status = $_SESSION["account_group"];
			if ($_SESSION["account_group"] == 1)
			{
				$account_access = $_SESSION["account_access"];
				$access = " AND (page_access <= :account_access)";
				$param = array("page_parent" => $this->key,"account_status" => $account_status,"account_access" => $account_access);
			}
			else
			{
				$param = array("page_parent" => $this->key,"account_status" => $account_status);
			}
		}
		else
		{
			$param = array("page_parent" => $this->key,"account_status" => $account_status);
		}
		$access .= " AND (page_status <> 3)";
		if ($this->order != "")
		{
			$order = $this->order;
		}
		else
		{
			$order = "page_order DESC, page_title";
		}
		if ($this->template != "")
		{
			$param2 = array("template_name" => $this->template);
			$query2 = "SELECT template_name FROM ".$this->prefix."template WHERE template_name = :template_name";
			if ($this->db->count($query2,$param2) > 0)
			{
				$tempStr = " AND (page_template = '".$this->template."')";
			}
			else
			{
				$tempStr = "";
			}
		}
		else
		{
			$tempStr = "";
		}
		if ($this->checkhide == false)
		{
			$hideStr = "";
		}
		else
		{
			$hideStr = " AND (page_hide = 0)";
		}
		if ($this->stepsize != 0)
		{
			$limitStr = " LIMIT ".$this->start.", ".$this->stepsize;
		}
		else
		{
			$limitStr = "";
		}
		if ($this->navigation)
		{
			$query = "SELECT page_key,page_template,page_path,page_extern,page_parent,page_navigation,page_title,page_headline,page_access,page_lang,page_start,page_main,page_hide,page_att1,page_att2 FROM ".$this->prefix."page WHERE (page_parent = :page_parent) AND (page_status <= :account_status) $tempStr $hideStr $access ORDER BY $order $limitStr";
		}
		else 
		{
			$query = "SELECT * FROM ".$this->prefix."page WHERE (page_parent = :page_parent) AND (page_status <= :account_status) $tempStr $hideStr $access ORDER BY $order $limitStr";
		}
		if (!$this->resultset)
		{
			$retArr = $this->db->select($query,$param);
			if ($this->setwebsite)
			{
				$tempArr = array();
				foreach ($retArr as $row)
				{
					$row["page_path"] = "website.php?id=".$row["page_path"];
					array_push($tempArr,$row);
				}
				$retArr = $tempArr;			
			}
			if ($this->checkexternal)
			{
				$tempArr = array();
				foreach ($retArr as $row)
				{
					if (isset($_GET["export"]))
					{
						if ($row["page_extern"] != "")
						{
							$row["page_path"] = $row["page_extern"];
							$row["external"] = 1;
							array_push($tempArr,$row);
						}
						else
						{
							$row["external"] = 0;
							array_push($tempArr,$row);
						}
					}
					else 
					{
						if (($row["page_extern"] != "") && (($_SESSION["account_group"] < 2) || ((isset($_SESSION["preview"])) && ($_SESSION["preview"] == 1))))
						{
							$row["page_path"] = $row["page_extern"];
							$row["external"] = 1;
							array_push($tempArr,$row);
						}
						else
						{
							$row["external"] = 0;
							array_push($tempArr,$row);
						}						
					}
				}
				$retArr = $tempArr;
			}
			return $retArr;
		}
		else
		{
			return $this->db->selectResult($query,$param);
		}
	}
}
?>