<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

class User
{
	private $db;
	private $prefix;
	private $set;
	private $session;
		
	public function User()
	{
		global $db_praefix,$oe_set,$oe_db,$oe_session;
		$this->prefix = $db_praefix;
		$this->db = $oe_db;
		$this->set = $oe_set;
		$this->session = $oe_session;
	}
		
	public function setCookie()
	{
		setcookie("account_email",$_SESSION["account_email"],time()+ (3600 * 24 * 365));
		setcookie("account_password",$_SESSION["account_password"],time()+ (3600 * 24 * 365));
	}
	
	public function resetCookie()
	{
		if (isset($_COOKIE["account_email"]))
		{
			setcookie("account_email","");
		}
		if (isset($_COOKIE["account_password"]))
		{
			setcookie("account_password","");
		}
	}
	
	private function accountExistst($account_email)
	{
		$param = array("account_email" => $account_email);
		$query = "SELECT * FROM ".$this->prefix."account WHERE (account_email = :account_email) AND (account_lock = 0) AND (account_group > 1)";
		$resArr = $this->db->count($query,$param);
		if ($this->db->count($query,$param) == 1)
		{
			return true;
		}
		else
		{
			return false;			
		}
	}

	private function getAccountLogin($account_email)
	{
		$param = array("account_email" => $account_email);
		$query = "SELECT * FROM ".$this->prefix."account WHERE (account_email = :account_email) AND (account_lock = 0) AND (account_group > 1)";
		return $this->db->row($query,$param);
	}
	
	private function checkPasswordCounter($resArr)
	{
		if ($this->set->checkPasswordLockRepeat() > 0)
		{
			if ($resArr["account_passwordcounter_time"] != "0000-00-00 00:00:00")
			{
				if (strtotime(date("Y-m-d H:i:s")) < strtotime($resArr["account_passwordcounter_time"]))
				{
					if ($resArr["account_passwordcounter"] != 0)
					{
						$param = array("account_key" => $resArr["account_key"]);
						$query = "UPDATE ".$this->prefix."account SET account_passwordcounter = 0 WHERE account_key = :account_key";
						$this->db->update($query,$param);
					}
					$_SESSION["account_password_error"] = 1;
					return false;
				}
				else
				{
					$param = array("account_key" => $resArr["account_key"],"account_passwordcounter_time" => "0000-00-00 00:00:00");
					$query = "UPDATE ".$this->prefix."account SET account_passwordcounter = 0, account_passwordcounter_time = :account_passwordcounter_time WHERE account_key = :account_key";
					$this->db->update($query,$param);
					return true;
				}
			}
			else
			{
				return true;
			}
		}
		else
		{
			return true;
		}
	}
	
	private function clearPasswordCounter($resArr)
	{
		if ($this->set->checkPasswordLockRepeat() > 0)
		{
			$param = array("account_key" => $resArr["account_key"],"account_passwordcounter_time" => "0000-00-00 00:00:00");
			$query = "UPDATE ".$this->prefix."account SET account_passwordcounter = 0,account_passwordcounter_time = :account_passwordcounter_time WHERE account_key = :account_key";
			$this->db->update($query,$param);
		}		
	}
	
	private function updatePasswordCounter($resArr)
	{
		if ($this->set->checkPasswordLockRepeat() > 0)
		{
			$param = array("account_key" => $resArr["account_key"],"account_passwordcounter" => $resArr["account_passwordcounter"] + 1);
			$query = "UPDATE ".$this->prefix."account SET account_passwordcounter = :account_passwordcounter WHERE account_key = :account_key";
			$this->db->update($query,$param);
			if (($resArr["account_passwordcounter"] + 1) >= $this->set->checkPasswordLockRepeat())
			{
				$interval1 = $this->set->checkPasswordLockTime();
				$param = array("account_key" => $resArr["account_key"]);
				$query = "UPDATE ".$this->prefix."account SET account_passwordcounter = 0,account_passwordcounter_time = date_add(now(), INTERVAL $interval1 MINUTE) WHERE account_key = :account_key";
				$this->db->update($query,$param);
				$_SESSION["account_password_error"] = 1;			
			}
		}
	}
	
	private function updateAccountTimer($resArr)
	{
		if ($this->set->checkPasswordRepeatTime() > 0)
		{
			if ($resArr["account_passwordchange_time"] == "0000-00-00 00:00:00")
			{
				$interval1 = $this->set->checkPasswordRepeatTime();
				$param = array("account_key" => $resArr["account_key"]);
				$query = "UPDATE ".$this->prefix."account SET account_passwordchange_time = date_add(now(), INTERVAL $interval1 MINUTE) WHERE account_key = :account_key";
				$this->db->update($query,$param);
				$resArr = $this->getAccountLogin($resArr["account_email"]);
			}
			if (strtotime(date("Y-m-d H:i:s")) > strtotime($resArr["account_passwordchange_time"]))
			{
				$param = array("account_key" => $resArr["account_key"]);
				$query = "UPDATE ".$this->prefix."account SET account_passwordchanged = 1 WHERE account_key = :account_key";
				$this->db->update($query,$param);
				$_SESSION["account_passwordchanged"] = 1;
			}
		}
	}
	
	public function login($account_email,$account_password)
	{
		if ($this->accountExistst($account_email))
		{
			$resArr = $this->getAccountLogin($account_email);
			if (($this->set->getSystemLock()) && ($resArr["account_group"] == 3))
			{
				return false;
			}
			else
			{
				if ($this->checkPasswordCounter($resArr))
				{
					if ($resArr["account_password"] == md5($account_password))
					{
						SecureSession::open();
						foreach (array_keys($resArr) as $value)
						{
							$_SESSION[$value] = $resArr[$value];
						}
						$_SESSION["preview"] = 0;
						$this->clearPasswordCounter($resArr);
						$this->updateAccountTimer($resArr);
						$this->session->setOeCookie();
						if (isset($_POST["page_path"]))
						{
							?>
							<script type="text/javascript">
							location.href="website.php?id=<?= $_POST["page_path"]; ?>";
							</script>
							<?
						}
					}
					else
					{
						$this->updatePasswordCounter($resArr);
					}		
				}
				else
				{
					return false;
				}
			}
		}
		else
		{
			return false;
		}
	}
	
	public function password($account_password,$account_password_new)
	{
		$oe_password = new Password();
		$password_old = $_SESSION["account_password"];
		if (($account_password != "") && ($account_password_new != ""))
		{
			if ($account_password == $account_password_new)
			{
				if (md5($account_password) != $password_old)
				{
					if ($oe_password->checkLength($account_password))
					{
						if ($oe_password->checkComplexity($account_password))
						{
							$_SESSION["oe_dialog_changepassword"] = 0;
							$_SESSION["account_passwordchanged"] = 0;
							$interval1 = $this->set->checkPasswordRepeatTime();
							$param = array("account_key" => $_SESSION["account_key"],"account_password" => md5($account_password));
							$query = "UPDATE ".$this->prefix."account SET account_password = :account_password, account_passwordchanged = 0,account_passwordchange_time = date_add(now(), INTERVAL $interval1 MINUTE) WHERE account_key = :account_key";
							$this->db->update($query,$param);
							header("Location: website.php");
						}
						else
						{
							$_SESSION["oe_dialog_changepassword"] = 1;
						}
					}
					else
					{
						$_SESSION["oe_dialog_changepassword"] = 2;
					}
				}
				else
				{
					$_SESSION["oe_dialog_changepassword"] = 3;
				}
			}
			else
			{
				$_SESSION["oe_dialog_changepassword"] = 4;
			}
		}
		else
		{
			$_SESSION["oe_dialog_changepassword"] = 5;
		}
	}
	
	public function logout()
	{
		global $oe_https;
		$this->session->unsetOeCookie();
		session_unset();
		$_SESSION = array();
		session_destroy();
		setcookie(session_name(),"",0,"/",null,$oe_https);		
	}

	public function isAdmin()
	{
		if (isset($_GET["export"]))
		{
			return false;
		}
		else 
		{
			if ((isset($_SESSION["account_group"])) && ($_SESSION["account_group"] > 1))
			{
				return true;
			}
			else
			{	
				return false;
			}
		}
	}

	public function getAdmins()
	{
		$query = "SELECT * FROM ".$this->prefix."account WHERE account_group = 2 ORDER BY account_lastname";
		return $this->db->select($query);
	}
	
	public function getAuthors()
	{
		$query = "SELECT * FROM ".$this->prefix."account WHERE account_group = 3 ORDER BY account_lastname";
		return $this->db->select($query);
	}

	public function getGroup($account_group)
	{
		$group_name = "";
		switch ($account_group)
		{
	 	   	case "1":
				$group_name = "User";
	        break;
	 	   	case "2":
				$group_name = "Administrator";
	        break;
	 	   	case "3":
				$group_name = "Author";
	        break;
		}
		return $group_name;
	}

	public function isAdministrator()
	{
		if ((isset($_SESSION["preview"])) && ($_SESSION["preview"] == 1))
		{
			return false;
		}
		else
		{
			if ((isset($_SESSION["account_group"])) && ($_SESSION["account_group"] == 2))
			{
				return true;
			}
			else
			{	
				return false;
			}
		}		
	}
	
	public function isAuthor()
	{
		if ((isset($_SESSION["preview"])) && ($_SESSION["preview"] == 1))
		{
			return false;
		}
		else
		{
			if ((isset($_SESSION["account_group"])) && ($_SESSION["account_group"] == 3))
			{
				return true;
			}
			else
			{	
				return false;
			}
		}		
	}
	
	public function pagePermission($k,$useSession = false)
	{
		global $oe_page;
		$perm = false;
		$pageArr = $oe_page->getPageKey($k,true,true);
		if (isset($_GET["export"]))
		{
			return false;
		}
		else 
		{
			if ($this->set->getPagePermission() == 0)
			{
				if (($_SESSION["account_group"] == 2) || (($_SESSION["account_group"] == 3)))
				{
					return true;
				}
				else
				{
					return false;		
				}
			}
			else
			{
				$perm = false;
				$permset = 0;
				if ($_SESSION["account_group"] == 2)
				{
					$perm = true;
				}
				elseif ($_SESSION["account_group"] == 3)
				{
					$oe_template = new Template();
					if ($oe_template->checkTemplatePermission($k))
					{
						$pageArr = $oe_page->getPageKey($k,false,true);
						$page_parent = $pageArr["page_parent"];
						$account_key = $_SESSION["account_key"];
						$param = array("account_key" => $account_key, "page_key" => $k);
						$query = "SELECT perm_key,perm_type FROM ".$this->prefix."permission WHERE account_key = :account_key AND page_key = :page_key";
						$permArr = $this->db->row($query,$param);
						if (sizeof($permArr) > 1)
						{
							if ($permArr["perm_type"] == 0)
							{
								$perm = true;
								$permset = 1;
							}					
							if ($permArr["perm_type"] == 1)
							{
								$perm = false;
								$permset = 1;
							}					
						}
						else
						{
							if (($useSession) && (isset($_SESSION["oe_permission_list"])))
							{
								$permArrSess = array();	
								$permArrOld = $_SESSION["oe_permission_list"];
								if (in_array($k,$permArrOld))
								{
									error_log("USE SESSION PERMISSION");
									$perm = true;
									$permset = 1;
								}
								else 
								{	
									while (($page_parent != 0) && ($permset == 0))
									{
										$page_key = $page_parent;
										if ($page_key == 337)
										{
											echo "Drin";
										}
										$pageArr = $oe_page->getPageKey($page_parent,true,true);
										$page_parent = $pageArr["page_parent"];
										$account_key = $_SESSION["account_key"];
										if (!in_array($k,$permArrOld))
										{
											array_push($permArrSess,$page_key);
										}
										$param = array("account_key" => $account_key, "page_key" => $page_key);
										$query = "SELECT perm_key,perm_type FROM ".$this->prefix."permission WHERE account_key = :account_key AND page_key = :page_key";
										$permArr2 = $this->db->row($query,$param);
										if (sizeof($permArr2) > 1)
										{
											if ($permArr2["perm_type"] == 0)
											{
												$permArrNew = array_merge($permArrOld,$permArrSess);
												$_SESSION["oe_permission_list"] = $permArrNew;
												$perm = true;
												$permset = 1;
												
											}					
											if ($permArr2["perm_type"] == 1)
											{
												$perm = false;
												$permset = 1;
											}					
										}
									}
								}
							}
							else
							{
								while (($page_parent != 0) && ($permset == 0))
								{
									$page_key = $page_parent;
									$pageArr = $oe_page->getPageKey($page_parent,true,true);
									$page_parent = $pageArr["page_parent"];
									$account_key = $_SESSION["account_key"];
									$param = array("account_key" => $account_key, "page_key" => $page_key);
									$query = "SELECT perm_key,perm_type FROM ".$this->prefix."permission WHERE account_key = :account_key AND page_key = :page_key";
									$permArr2 = $this->db->row($query,$param);
									if (sizeof($permArr2) > 1)
									{
										if ($permArr2["perm_type"] == 0)
										{
											$perm = true;
											$permset = 1;
											
										}					
										if ($permArr2["perm_type"] == 1)
										{
											$perm = false;
											$permset = 1;
										}					
									}
								}
							}
						}
					}
					else
					{
						return false;
					}
				}
				else
				{
					$perm = false;
				}
				return $perm;
			}		
		}
	}
	
	public function poolPermission($k)
	{
		if ($this->set->getPagePermission() == 0)
		{
			return true;
		}
		else
		{
			$perm = false;
			$permset = 0;
			if ($_SESSION["account_group"] == 2)
			{
				$perm = true;
			}
			elseif ($_SESSION["account_group"] == 3)
			{
				$param = array("folder_key" => $k);
				$query = "SELECT * FROM ".$this->prefix."filepool WHERE folder_key = :folder_key";
				$folderArr = $this->db->row($query,$param);
				$folder_parent = $folderArr["folder_parent"];
				$account_key = $_SESSION["account_key"];
				$param = array("account_key" => $account_key,"folder_key" => $k);
				$query = "SELECT * FROM ".$this->prefix."poolpermission WHERE account_key = :account_key AND folder_key = :folder_key";
				$permArr = $this->db->row($query,$param);
				if (sizeof($permArr) > 1)
				{
					if ($permArr["perm_type"] == 0)
					{
						$perm = true;
						$permset = 1;
					}					
					if ($permArr["perm_type"] == 1)
					{
						$perm = false;
						$permset = 1;
					}					
				}
				else
				{
					while (($folder_parent != 0) && ($permset == 0))
					{
						$folder_key = $folder_parent;
						$param = array("folder_key" => $folder_parent);
						$query = "SELECT * FROM ".$this->prefix."filepool WHERE folder_key = :folder_key";
						$folderArr = $this->db->row($query,$param);
						$folder_parent = $folderArr["folder_parent"];
						$account_key = $_SESSION["account_key"];
						$param = array("account_key" => $account_key, "folder_key" => $folder_key);
						$query = "SELECT * FROM ".$this->prefix."poolpermission WHERE account_key = :account_key AND folder_key = :folder_key";
						$permArr2 = $this->db->row($query,$param);
						if (sizeof($permArr2) > 1)
						{
							if ($permArr2["perm_type"] == 0)
							{
								$perm = true;
								$permset = 1;
							}					
							if ($permArr2["perm_type"] == 1)
							{
								$perm = false;
								$permset = 1;
							}					
						}
					}
				}
			}
			else
			{
				$perm = false;
			}
			return $perm;		
		}
	}	
	
	public function getAccount($account_key)
	{
		$param = array("account_key" => $account_key);
		$query = "SELECT * FROM ".$this->prefix."account WHERE account_key = :account_key";
		return $this->db->row($query,$param);
	}
	
	public function deleteAccount($account_key)
	{
		$param = array("account_key" => $account_key);
		$query = "DELETE FROM ".$this->prefix."account WHERE account_key = :account_key";
		$this->db->delete($query,$param);
	}	

	public function getFreeaccounts()
	{
		$query = "SELECT account_key FROM ".$this->prefix."account WHERE (account_group = 1) AND (account_lock = 0) ORDER BY account_lastname";
		return $this->db->count($query);
	}
	
	public function getAdminaccounts()
	{
		$query = "SELECT account_key FROM ".$this->prefix."account WHERE (account_group != 1) AND (account_group != 0) AND (account_lock = 0) ORDER BY account_lastname";
		return $this->db->count($query);
	}
	
	public function getInfoaccounts()
	{
		$query = "SELECT account_key FROM ".$this->prefix."account WHERE (account_group != 0) AND (account_lock = 0) AND (account_info = 1) ORDER BY account_lastname";
		return $this->db->count($query);
	}
}
?>