<?php

/**
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * @package openEngine
 * @author Stephan Raabe
 */

/* ----------------------------------------------------------------------------
Database Wrapper
---------------------------------------------------------------------------- */

function connectDB()
{
	global $oe_db,$db_server, $db_user, $db_password, $db_name, $site_encoding;
	return $oe_db->connectDB($db_server, $db_user, $db_password, $db_name, $site_encoding);
}

function closeDB($link)
{
	global $oe_db;
	$oe_db->closeDB($link);
}

/* ----------------------------------------------------------------------------
Setting Wrapper
---------------------------------------------------------------------------- */

$site_name = $oe_set->getSiteName();

$site_url = $oe_set->getSiteUrl();

$site_admin	= $oe_set->getSiteAdmin();

$page_meta1 = $oe_set->getMeta("page_meta1");

$page_meta2 = $oe_set->getMeta("page_meta2");

$page_meta3 = $oe_set->getMeta("page_meta3");

$page_meta4 = $oe_set->getMeta("page_meta4");

$page_meta5 = $oe_set->getMeta("page_meta5");

$page_meta6 = $oe_set->getMeta("page_meta6");

$page_meta7 = $oe_set->getMeta("page_meta7");

$page_meta8 = $oe_set->getMeta("page_meta8");

$page_meta9 = $oe_set->getMeta("page_meta9");

$page_meta10 = $oe_set->getMeta("page_meta10");

$site_meta1 = $oe_set->getMeta("site_meta1");

$site_meta2 = $oe_set->getMeta("site_meta2");

$site_meta3 = $oe_set->getMeta("site_meta3");

$site_meta4 = $oe_set->getMeta("site_meta4");

$site_pool = $oe_set->getSitePool();

$cache_path = $oe_set->getCachePath();

$module_path = $oe_set->getModulePath();

/* ----------------------------------------------------------------------------
Session Wrapper
---------------------------------------------------------------------------- */

function setGuest()
{
	global $oe_user;
	$oe_session->setGuest();
}

function isAdmin()
{
	global $oe_user;
	return $oe_user->isAdmin();
}

function isAdministrator()
{
	global $oe_user;
	return $oe_user->isAdministrator();
}

function isAuthor()
{
	global $oe_user;
	return $oe_user->isAuthor();
}

function rewriteURL($strBuffer) 
{
	global $oe_user; 
  	return $oe_user->rewriteUrl($strBuffer);
}

/* ----------------------------------------------------------------------------
Page Wrapper
---------------------------------------------------------------------------- */

function translatePath($page_file)
{
	global $oe_page;
	return $oe_page->translatePath($page_file);
}

function getFolder($page_file)
{
	global $oe_page;
	return $oe_page->getFolder($page_file);
}

function isStage($page_key,$block)
{
	global $oe_page;
	return $oe_page->isStage($page_key,$block);
}

function get_page($page_path)
{
	global $oe_page;
	return $oe_page->getPage($page_path);
}

function get_filepool_key($k)
{
	global $oe_page;
	return $oe_page->getFilepoolKey($k);
}

function get_filepool($k)
{
	global $oe_page;
	return $oe_page->getFilepool($k);
}

function get_asset($an,$f)
{
	global $oe_page;
	return $oe_page->getAsset($an,$f);
}

function get_subpages($page_path)
{
	global $oe_page;
	$sub = new Structure();
	$pageArr = $oe_page->getPage($page_path);
	$sub->key = $pageArr["page_key"];
	$sub->resultset = true;
	return $sub->getStructure();
}

function get_subpages_date($page_path,$order)
{
	global $oe_page;
	$sub = new Structure();
	$pageArr = $oe_page->getPage($page_path);
	$sub->key = $pageArr["page_key"];
	$sub->order = "page_date_unformated $order";
	$sub->resultset = true;
	return $sub->getStructure();
}

function get_subpages_key($page_key)
{
	$sub = new Structure();
	$sub->key = $page_key;
	$sub->resultset = true;
	return $sub->getStructure();
}

function get_navigation_key($page_key)
{
	$sub = new Structure();
	$sub->key = $page_key;
	$sub->resultset = true;
	$sub->navigation = true;
	return $sub->getStructure();
}

function get_subpages_bytemplate($page_key,$template)
{
	$sub = new Structure();
	$sub->key = $page_key;
	$sub->template = $template;
	$sub->resultset = true;
	return $sub->getStructure();
}

function get_subpages_bytemplate_order($page_key,$template,$order)
{
	$sub = new Structure();
	$sub->key = $page_key;
	$sub->template = $template;
	$sub->order = $order;
	$sub->resultset = true;
	return $sub->getStructure();
}

function get_subpages_key_limit($page_key,$start,$stepsize)
{
	$sub = new Structure();
	$sub->key = $page_key;
	$sub->start = $start;
	$sub->stepsize = $stepsize;
	$sub->resultset = true;
	return $sub->getStructure();
}

function get_subpages_alphabetic($page_path,$field)
{
	global $oe_page;
	$sub = new Structure();
	$pageArr = $oe_page->getPage($page_path);
	$sub->key = $pageArr["page_key"];
	$sub->order = $field;
	$sub->resultset = true;
	return $sub->getStructure();	
}

function get_page_key($page_key)
{
	global $oe_page;	
	return $oe_page->getPageKey($page_key);
}

function get_tree_links($k)
{
	global $oe_page;	
	return $oe_page->getTreeLinks($k);
}

function get_lang_name($str)
{
	global $oe_page;
	return $oe_page->getLangName($str);
}

function writeRequire($formName,$fields)
{
	global $oe_page;
	$oe_page->writeRequire($formName,$fields);
}

function getStatus($page_status)
{
	global $oe_page;
	return $oe_page->getStatus($page_status);
}

function backpage()
{
	global $oe_page;
	return $oe_page->backPage();
}

function nextpage()
{
	global $oe_page;
	return $oe_page->nextPage();
}

function stringpool($name,$select)
{
	global $oe_page;
	return $oe_page->stringPool($name,$select);
}

function dbInclude($template_name)
{
	global $oe_page;
	return $oe_page->dbInclude($template_name);
}

function dbIncludePHPModule($template_name)
{
	global $oe_page;
	return $oe_page->dbIncludePHPModule($template_name);
}

function createThumb($infile,$outfile,$maxw,$maxh)
{
	/*
	global $oe_page;
	$oe_page->createThumb($infile,$outfile,$maxw,$maxh);
	*/
}

function outputDate($str)
{
	global $oe_page;
	return $oe_page->outputDate($str);
}

function formatDate($str,$sep)
{
	global $oe_page;
	return $oe_page->formatDate($str,$sep);
}

function get_searchresult($searchstring,$field_name,$stepsize,$step)
{
	global $oe_page;
	return $oe_page->getSearchresult($searchstring,$field_name,$stepsize,$step);
}

/* ----------------------------------------------------------------------------
Editor Wrapper
---------------------------------------------------------------------------- */

function editText($block,$tooltip,$output = "",$subpage = 0)
{
	$oe_edit = new TextEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}	
	$oe_edit->getEditor();
}	

function editItem($block,$tooltip,$output = "",$subpage = 0)
{
	$oe_edit = new ItemEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}
	$oe_edit->getEditor();
}

function editDate($block,$tooltip,$output = "",$subpage = 0)
{
	$delete = 0;
	$block_arr = explode(";",$block);
	$block = $block_arr[0];
	if (isset($block_arr[1]))
	{
		$delete = $block_arr[1];
	}
	$oe_edit = new DateEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}
	if ($delete == 0)
	{
		$oe_edit->deletedate = false;
	}
	$oe_edit->getEditor();
}

function editAuthorization($tooltip,$subpage = 0)
{
	$oe_edit = new AuthorizationEditor();
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	$oe_edit->getEditor();
}

function editModule($block,$tooltip,$subpage = 0)
{
	$oe_edit = new ModuleEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	$oe_edit->getEditor();
}

function editInclude($block,$tooltip,$output = "")
{
	$oe_edit = new IncludeEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}	
	$oe_edit->getEditor();
}

function editIframe($block,$tooltip,$output = "",$style = "")
{
	$oe_edit = new IframeEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->style = $style;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}	
	$oe_edit->getEditor();
}

function editUpload($block,$tooltip,$subpage = 0,$upload_path = "")
{
	$oe_edit = new UploadEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	$oe_edit->getEditor();
}

function editSelect($block,$select = array(),$tooltip,$subpage = 0)
{
	$oe_edit = new SelectEditor();
	$oe_edit->tooltip = $tooltip;
	$oe_edit->block = $block;
	$oe_edit->pagekey = $subpage;
	$oe_edit->selectarray = $select;
	$oe_edit->getEditor();
}

function editNew($tooltip,$template,$setpath = 0,$pagekey = 0,$icon = "system/img/oes_addpage.png")
{
	$oe_edit = new NewPageEditor();
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $pagekey;
	$oe_edit->template = $template;
	$oe_edit->icon = $icon;
	if ($setpath == 0)
	{
		$oe_edit->setpath = false;
	}
	$oe_edit->getEditor();
}

function editSubNavigation($tooltip,$pagekey = 0)
{
	$oe_edit = new PageOrderEditor();
	$oe_edit->tooltip = $tooltip;
	$oe_edit->getEditor();
}

function editDelete($tooltip,$subpage = 0)
{
	$oe_edit = new DeleteEditor();
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	$oe_edit->getEditor();	
}

function editIndividual($include,$tooltip,$name)
{
	$oe_edit = new IndividualEditor();
	$oe_edit->include = $include;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->name = $name;
	$oe_edit->getEditor();
}

function editHTML($block,$tooltip,$output = "",$subpage = 0)
{
	$oe_edit = new HTMLEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}
	$oe_edit->getEditor();	
}

function editSimpleText($block,$tooltip,$output = "",$subpage = 0)
{
	$oe_edit = new SimpleTextEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	if ($output == "no")
	{
		$oe_edit->returncontent = false;
	}
	$oe_edit->getEditor();	
}

function editPHP($block,$tooltip)
{
	$oe_edit = new PHPEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->getEditor();	
}

function editRelease($block,$tooltip,$subpage = 0)
{
	$oe_edit = new ReleaseEditor();
	$oe_edit->block = $block;
	$oe_edit->tooltip = $tooltip;
	$oe_edit->pagekey = $subpage;
	$oe_edit->getEditor();		
}

/* ----------------------------------------------------------------------------
Output Wrapper
---------------------------------------------------------------------------- */

function isPreview()
{
	global $oe_output;
	return $oe_output->isPreview();
}

function outputBlock($block,$subpage = 0)
{
	global $oe_output;
	return $oe_output->outputBlock($block,$subpage);
}

function outputModule($block,$static_path = "",$subpage = 0)
{
	global $oe_output;
	$oe_output->outputModule($block,$static_path,$subpage);
}	

function includeModule($output,$static_path = "")
{	
	global $oe_output;
	$oe_output->includeModule($output,$static_path);
}

function outputAlttext($block,$subpage = 0)
{
	global $oe_output;
	return $oe_output->outputAlttext($block,$subpage);
}

function outputInclude($block)
{
	global $oe_output;
	return $oe_output->outputInclude($block);
}

function outputIframe($block,$style)
{
	global $oe_output;
	return $oe_output->outputIframe($block,$style);
}

function isContent($block,$subpage = 0)
{
	global $oe_output;
	return $oe_output->isContent($block,$subpage);
}

function outputSelect($block,$select,$subpage = 0)
{
	global $oe_output;
	$oe_output->outputSelect($block,$select,$subpage);
}
?>